package de.ubt.wm.sb.junit;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.ubt.wm.sb.model.HitTechnique;
import de.ubt.wm.sb.probs.Prob_DefRec;
import de.ubt.wm.sb.probs.Prob_Hit;

public class ComputeModifiedProbsTest {

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void test() {
		Prob_Hit recdef = new Prob_DefRec(HitTechnique.recdef, 21, null, 0.52, 0.19, null);
		Prob_Hit rec = new Prob_DefRec(HitTechnique.rec, 13, recdef, 0.69, 0, null);
		Prob_Hit r_m = new Prob_DefRec(HitTechnique.r_m, 4, rec, 0.5, 0, null);
		Prob_Hit r_m_hard = new Prob_DefRec(HitTechnique.r_m, 2, r_m, 0.5, 0, null);
		Prob_Hit.minObs = 20;
		r_m_hard.setModifiedProbs();
		assertTrue("new modified Succ Probability should be 0.6245 but is " + r_m_hard.getSuccProb_mod(), r_m_hard.getSuccProb_mod() <= 0.6245+0.00001 && r_m_hard.getSuccProb_mod() >= 0.6245-0.00001);
	}

}
