package de.ubt.wm.sb.junit;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.ubt.wm.sb.model.Field;

public class FieldTest {

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void someSimpleNeighbourTests() {
		assertTrue("A13 is neighbour of A22", Field.A13.isNeighbour(Field.A22));
		assertFalse("B02 is neighbour of A12", Field.B02.isNeighbour(Field.A12));
		
		assertTrue("A02 is north of A12", Field.A02.isNorthOf(Field.A12));
		assertFalse("A02 is NOT east of  A12", Field.A02.isEastOf(Field.A12));

		assertTrue("A13 is east of A22", Field.A13.isEastOf(Field.A22));
		
	}
	
	@Test
	public void atTheNetTest(){
		assertTrue("A31 am Netz", Field.A31.isAtTheNet());
		assertTrue("A22 NICHT am Netz", !Field.A22.isAtTheNet());
		assertTrue("B31 am Netz", Field.B31.isAtTheNet());
		assertTrue("B22 NICHT am Netz", !Field.B22.isAtTheNet());
	}
	
}
