package de.ubt.wm.sb.gui;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;

import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.JSlider;
import javax.swing.JSpinner;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.SwingConstants;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.JButton;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;

public class EditPane extends JTabbedPane{

	private static final long serialVersionUID = 3055517578879237590L;
	JTextField txt_teamA;
	private JTextField txt_nameA1;
	private JTextField txt_skillsTeamA;
	private JTextField txt_nameA2;
	
	JTextField txt_teamB;
	private JTextField txt_nameB1;
	private JTextField txt_skillsTeamB;
	private JTextField txt_nameB2;
	
	private JCheckBox chckbx_Gui;
	JSpinner spinner_MaxNumberOfSets;
	private JSlider slider_speed;
	private ButtonGroup buttonGroup = new ButtonGroup();
	String choosenStratTeamA;
	JFileChooser fc;

	JLabel label_pi_h_serve_tech_A1;
	JLabel label_pi_h_serve_tech_A2;
	JLabel label_pi_h_field_tech_A1;
	JLabel label_pi_h_field_tech_A2;
	JLabel label_pi_h_serve_field_A1;
	JLabel label_pi_h_serve_field_A2;
	JLabel label_pi_h_field_field_A1;
	JLabel label_pi_h_field_field_A2;
	
	JLabel label_pi_b;
	JLabel label_pi_s;
	
	JSlider slider_pi_h_serve_tech_A1;
	JSlider slider_pi_h_serve_tech_A2;
	JSlider slider_pi_h_field_tech_A1;
	JSlider slider_pi_h_field_tech_A2;
	JSlider slider_pi_h_serve_field_A1;
	JSlider slider_pi_h_serve_field_A2;
	JSlider slider_pi_h_field_field_A1;
	JSlider slider_pi_h_field_field_A2;

	JSlider slider_pi_b;
	JSlider slider_pi_s;
	
	JLabel label_pi_h_serve_tech_B1;
	JLabel label_pi_h_serve_tech_B2;
	JLabel label_pi_h_field_tech_B1;
	JLabel label_pi_h_field_tech_B2;
	JLabel label_pi_h_serve_field_B1;
	JLabel label_pi_h_serve_field_B2;
	JLabel label_pi_h_field_field_B1;
	JLabel label_pi_h_field_field_B2;
	
	JLabel label_pi_b_B;
	JLabel label_pi_s_B;
	
	JSlider slider_pi_h_serve_tech_B1;
	JSlider slider_pi_h_serve_tech_B2;
	JSlider slider_pi_h_field_tech_B1;
	JSlider slider_pi_h_field_tech_B2;
	JSlider slider_pi_h_serve_field_B1;
	JSlider slider_pi_h_serve_field_B2;
	JSlider slider_pi_h_field_field_B1;
	JSlider slider_pi_h_field_field_B2;

	JSlider slider_pi_b_B;
	JSlider slider_pi_s_B;
	
	public EditPane(){
		//JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.TOP);
	    this.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
	    
	    //Create a file chooser
        fc = new JFileChooser("./data");
        FileNameExtensionFilter filter = new FileNameExtensionFilter("gProbs", ".csv", "csv");
        fc.setFileFilter(filter);
	    
	    //////////////////////////////////////////
	    JPanel pannelYourTeam = new JPanel();
	    //////////////////////////////////////////
	    this.addTab("Your Team", pannelYourTeam);
	    
	    pannelYourTeam.setBorder(null);
	    GridBagLayout gbl_pannelYourTeam = new GridBagLayout();
	    gbl_pannelYourTeam.columnWidths = new int[] {0, 250, 250, 0};
	    gbl_pannelYourTeam.rowHeights = new int[] {30, 30, 0, 60, 30, 30, 0, 0, 30};
	    gbl_pannelYourTeam.columnWeights = new double[]{0.0, 1.0, 1.0, 0.0};
	    gbl_pannelYourTeam.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 0.0, 0.0};
	    pannelYourTeam.setLayout(gbl_pannelYourTeam);
		
		JLabel lblTeamName_1 = new JLabel("Team Name");
		GridBagConstraints gbc_lblTeamName_1 = new GridBagConstraints();
		gbc_lblTeamName_1.insets = new Insets(0, 0, 5, 5);
		gbc_lblTeamName_1.gridx = 1;
		gbc_lblTeamName_1.gridy = 1;
		pannelYourTeam.add(lblTeamName_1, gbc_lblTeamName_1);
		
		JLabel lblTeamName_Skills = new JLabel("Skills");
		GridBagConstraints gbc_lblTeamName_Skills = new GridBagConstraints();
		gbc_lblTeamName_Skills.insets = new Insets(0, 0, 5, 5);
		gbc_lblTeamName_Skills.gridx = 1;
		gbc_lblTeamName_Skills.gridy = 2;
		pannelYourTeam.add(lblTeamName_Skills, gbc_lblTeamName_Skills);
		
		txt_teamA = new JTextField("Germany");
		txt_teamA.setHorizontalAlignment(SwingConstants.CENTER);
		txt_teamA.setToolTipText("Team A");
		GridBagConstraints gbc_txt_q = new GridBagConstraints();
		gbc_txt_q.insets = new Insets(0, 0, 5, 5);
		gbc_txt_q.fill = GridBagConstraints.HORIZONTAL;
		gbc_txt_q.gridx = 2;
		gbc_txt_q.gridy = 1;
		pannelYourTeam.add(txt_teamA, gbc_txt_q);
		txt_teamA.setColumns(10);
		
	    txt_skillsTeamA = new JTextField("data/GER/allMatchesExceptFinal/GER_allMatchesExceptFinal.gprobs.csv");
	    txt_skillsTeamA.setHorizontalAlignment(SwingConstants.CENTER);
	    txt_skillsTeamA.setToolTipText("Team A");
		GridBagConstraints gbc_txt_q1 = new GridBagConstraints();
		gbc_txt_q1.insets = new Insets(0, 0, 5, 5);
		gbc_txt_q1.fill = GridBagConstraints.HORIZONTAL;
		gbc_txt_q1.gridx = 2;
		gbc_txt_q1.gridy = 2;
		pannelYourTeam.add(txt_skillsTeamA, gbc_txt_q1);
		txt_skillsTeamA.setColumns(10);
	    
	    JButton btnSearch = new JButton("Search...");
	    btnSearch.setToolTipText("Search Skill Data File");
	    GridBagConstraints gbc_btnSearch = new GridBagConstraints();
	    gbc_btnSearch.insets = new Insets(0, 0, 5, 0);
	    gbc_btnSearch.gridx = 3;
	    gbc_btnSearch.gridy = 2;
	    pannelYourTeam.add(btnSearch, gbc_btnSearch);
	    
	    btnSearch.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				int returnVal = fc.showOpenDialog(EditPane.this);
				 
	            if (returnVal == JFileChooser.APPROVE_OPTION) {
	                File file = fc.getSelectedFile();
	                try {
	                	txt_skillsTeamA.setText(file.getCanonicalPath());
						System.out.println("Opening: " + file.getCanonicalPath());
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
	            } else {
	            	System.out.println("Open command cancelled by user.");
	            }
			}
	    });
	    
	    {
	    JPanel panelPlayerA1 = new JPanel();
	    panelPlayerA1.setBorder(new TitledBorder(null, "Player 1", TitledBorder.LEADING, TitledBorder.TOP, null, null));
	    GridBagConstraints gbc_panelPlayerA1 = new GridBagConstraints();
	    gbc_panelPlayerA1.insets = new Insets(0, 0, 5, 5);
	    gbc_panelPlayerA1.fill = GridBagConstraints.BOTH;
	    gbc_panelPlayerA1.gridx = 1;
	    gbc_panelPlayerA1.gridy = 3;
	    pannelYourTeam.add(panelPlayerA1, gbc_panelPlayerA1);
	    GridBagLayout gbl_panelPlayerA1 = new GridBagLayout();
	    gbl_panelPlayerA1.columnWidths = new int[]{0, 0, 0};
	    gbl_panelPlayerA1.rowHeights = new int[]{0, 0, 0};
	    gbl_panelPlayerA1.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
	    gbl_panelPlayerA1.rowWeights = new double[]{0.0, 0.0, Double.MIN_VALUE};
	    panelPlayerA1.setLayout(gbl_panelPlayerA1);
	    
	    JLabel label_name = new JLabel("Name");
	    GridBagConstraints gbc_label = new GridBagConstraints();
	    gbc_label.anchor = GridBagConstraints.EAST;
	    gbc_label.insets = new Insets(0, 0, 5, 5);
	    gbc_label.gridx = 0;
	    gbc_label.gridy = 0;
	    panelPlayerA1.add(label_name, gbc_label);
	    
	    txt_nameA1 = new JTextField("Brink");
	    txt_nameA1.setColumns(10);
	    GridBagConstraints gbc_txtPlayerA1 = new GridBagConstraints();
	    gbc_txtPlayerA1.fill = GridBagConstraints.HORIZONTAL;
	    gbc_txtPlayerA1.insets = new Insets(0, 0, 5, 0);
	    gbc_txtPlayerA1.gridx = 1;
	    gbc_txtPlayerA1.gridy = 0;
	    panelPlayerA1.add(txt_nameA1, gbc_txtPlayerA1);
	    
	    JPanel panelPlayerA2 = new JPanel();
	    panelPlayerA2.setBorder(new TitledBorder(null, "Player 2", TitledBorder.LEADING, TitledBorder.TOP, null, null));
	    GridBagConstraints gbc_panelPlayerA2 = new GridBagConstraints();
	    gbc_panelPlayerA2.insets = new Insets(0, 0, 5, 5);
	    gbc_panelPlayerA2.fill = GridBagConstraints.BOTH;
	    gbc_panelPlayerA2.gridx = 2;
	    gbc_panelPlayerA2.gridy = 3;
	    pannelYourTeam.add(panelPlayerA2, gbc_panelPlayerA2);
	    GridBagLayout gbl_panelPlayerA2 = new GridBagLayout();
	    gbl_panelPlayerA2.columnWidths = new int[]{0, 0, 0};
	    gbl_panelPlayerA2.rowHeights = new int[]{0, 0, 0};
	    gbl_panelPlayerA2.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
	    gbl_panelPlayerA2.rowWeights = new double[]{0.0, 0.0, Double.MIN_VALUE};
	    panelPlayerA2.setLayout(gbl_panelPlayerA2);
	    
	    label_name = new JLabel("Name");
	    gbc_label = new GridBagConstraints();
	    gbc_label.anchor = GridBagConstraints.EAST;
	    gbc_label.insets = new Insets(0, 0, 5, 5);
	    gbc_label.gridx = 0;
	    gbc_label.gridy = 0;
	    panelPlayerA2.add(label_name, gbc_label);
	    
	    txt_nameA2 = new JTextField("Reckermann");
	    txt_nameA2.setColumns(10);
	    GridBagConstraints gbc_txtPlayerA2 = new GridBagConstraints();
	    gbc_txtPlayerA2.fill = GridBagConstraints.HORIZONTAL;
	    gbc_txtPlayerA2.insets = new Insets(0, 0, 5, 0);
	    gbc_txtPlayerA2.gridx = 1;
	    gbc_txtPlayerA2.gridy = 0;
	    panelPlayerA2.add(txt_nameA2, gbc_txtPlayerA2);
	    }
	    
	    
	    /**
	     * sliders for strat
	     */
	    // serve-tech
	    {
	    JPanel panel_pi_h_serve_tech_A1 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_serve_tech_A1 = new GridBagConstraints();
	    gbc_panel_pi_h_serve_tech_A1.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_serve_tech_A1.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_serve_tech_A1.gridx = 1;
	    gbc_panel_pi_h_serve_tech_A1.gridy = 4;
	    pannelYourTeam.add(panel_pi_h_serve_tech_A1, gbc_panel_pi_h_serve_tech_A1);
	    GridBagLayout gbl_panel_pi_h_serve_tech_A1 = new GridBagLayout();
	    gbl_panel_pi_h_serve_tech_A1.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_serve_tech_A1.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_serve_tech_A1.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_serve_tech_A1.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_serve_tech_A1.setLayout(gbl_panel_pi_h_serve_tech_A1);
	    
	    JLabel label_1 = new JLabel("SF");
	    label_1.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_1 = new GridBagConstraints();
	    gbc_label_1.fill = GridBagConstraints.BOTH;
	    gbc_label_1.insets = new Insets(0, 0, 0, 5);
	    gbc_label_1.gridx = 0;
	    gbc_label_1.gridy = 0;
	    panel_pi_h_serve_tech_A1.add(label_1, gbc_label_1);
	    
	    slider_pi_h_serve_tech_A1 = new JSlider();
	    slider_pi_h_serve_tech_A1.setName("pi_h_serve_tech_A1_slider");
	    slider_pi_h_serve_tech_A1.setSnapToTicks(true);
	    slider_pi_h_serve_tech_A1.setPaintTicks(true);
	    slider_pi_h_serve_tech_A1.setPaintLabels(true);
	    GridBagConstraints gbc_slider = new GridBagConstraints();
	    gbc_slider.fill = GridBagConstraints.BOTH;
	    gbc_slider.insets = new Insets(0, 0, 0, 5);
	    gbc_slider.gridx = 1;
	    gbc_slider.gridy = 0;
	    panel_pi_h_serve_tech_A1.add(slider_pi_h_serve_tech_A1, gbc_slider);
	    
	    JLabel label_2 = new JLabel("SJ");
	    label_2.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_2 = new GridBagConstraints();
	    gbc_label_2.fill = GridBagConstraints.BOTH;
	    gbc_label_2.insets = new Insets(0, 0, 0, 5);
	    gbc_label_2.gridx = 2;
	    gbc_label_2.gridy = 0;
	    panel_pi_h_serve_tech_A1.add(label_2, gbc_label_2);
	    
	    label_pi_h_serve_tech_A1 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_serve_tech_A1 = new GridBagConstraints();
	    gbc_label_pi_h_serve_tech_A1.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_serve_tech_A1.gridx = 3;
	    gbc_label_pi_h_serve_tech_A1.gridy = 0;
	    panel_pi_h_serve_tech_A1.add(label_pi_h_serve_tech_A1, gbc_label_pi_h_serve_tech_A1);
	    }
	    
	    // field tech
	    {
	    JPanel panel_pi_h_field_tech_A1 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_field_tech_A1 = new GridBagConstraints();
	    gbc_panel_pi_h_field_tech_A1.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_field_tech_A1.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_field_tech_A1.gridx = 1;
	    gbc_panel_pi_h_field_tech_A1.gridy = 6;
	    pannelYourTeam.add(panel_pi_h_field_tech_A1, gbc_panel_pi_h_field_tech_A1);
	    GridBagLayout gbl_panel_pi_h_field_tech_A1 = new GridBagLayout();
	    gbl_panel_pi_h_field_tech_A1.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_field_tech_A1.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_field_tech_A1.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_field_tech_A1.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_field_tech_A1.setLayout(gbl_panel_pi_h_field_tech_A1);
	    
	    JLabel label_FP = new JLabel("FP");
	    label_FP.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_FP = new GridBagConstraints();
	    gbc_label_FP.fill = GridBagConstraints.BOTH;
	    gbc_label_FP.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FP.gridx = 0;
	    gbc_label_FP.gridy = 0;
	    panel_pi_h_field_tech_A1.add(label_FP, gbc_label_FP);
	    
	    slider_pi_h_field_tech_A1 = new JSlider();
	    slider_pi_h_field_tech_A1.setName("pi_h_field_tech_A1_slider");
	    slider_pi_h_field_tech_A1.setSnapToTicks(true);
	    slider_pi_h_field_tech_A1.setPaintTicks(true);
	    slider_pi_h_field_tech_A1.setPaintLabels(true);
	    GridBagConstraints gbc_slider_field_tech = new GridBagConstraints();
	    gbc_slider_field_tech.fill = GridBagConstraints.BOTH;
	    gbc_slider_field_tech.insets = new Insets(0, 0, 0, 5);
	    gbc_slider_field_tech.gridx = 1;
	    gbc_slider_field_tech.gridy = 0;
	    panel_pi_h_field_tech_A1.add(slider_pi_h_field_tech_A1, gbc_slider_field_tech);
	    
	    JLabel label_FS = new JLabel("FS");
	    label_FS.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_FS = new GridBagConstraints();
	    gbc_label_FS.fill = GridBagConstraints.BOTH;
	    gbc_label_FS.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FS.gridx = 2;
	    gbc_label_FS.gridy = 0;
	    panel_pi_h_field_tech_A1.add(label_FS, gbc_label_FS);
	    
	    label_pi_h_field_tech_A1 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_field_tech_A1 = new GridBagConstraints();
	    gbc_label_pi_h_field_tech_A1.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_field_tech_A1.gridx = 3;
	    gbc_label_pi_h_field_tech_A1.gridy = 0;
	    panel_pi_h_field_tech_A1.add(label_pi_h_field_tech_A1, gbc_label_pi_h_field_tech_A1);
	    }
	    
	    // serve-field
	    {
	    JPanel panel_pi_h_serve_field_A1 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_serve_field_A1 = new GridBagConstraints();
	    gbc_panel_pi_h_serve_field_A1.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_serve_field_A1.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_serve_field_A1.gridx = 1;
	    gbc_panel_pi_h_serve_field_A1.gridy = 5;
	    pannelYourTeam.add(panel_pi_h_serve_field_A1, gbc_panel_pi_h_serve_field_A1);
	    GridBagLayout gbl_panel_pi_h_serve_field_A1 = new GridBagLayout();
	    gbl_panel_pi_h_serve_field_A1.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_serve_field_A1.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_serve_field_A1.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_serve_field_A1.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_serve_field_A1.setLayout(gbl_panel_pi_h_serve_field_A1);
	    
	    JLabel label_1 = new JLabel("inside");
	    label_1.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_1 = new GridBagConstraints();
	    gbc_label_1.fill = GridBagConstraints.BOTH;
	    gbc_label_1.insets = new Insets(0, 0, 0, 5);
	    gbc_label_1.gridx = 0;
	    gbc_label_1.gridy = 0;
	    panel_pi_h_serve_field_A1.add(label_1, gbc_label_1);
	    
	    slider_pi_h_serve_field_A1 = new JSlider();
	    slider_pi_h_serve_field_A1.setName("pi_h_serve_field_A1_slider");
	    slider_pi_h_serve_field_A1.setSnapToTicks(true);
	    slider_pi_h_serve_field_A1.setPaintTicks(true);
	    slider_pi_h_serve_field_A1.setPaintLabels(true);
	    GridBagConstraints gbc_slider = new GridBagConstraints();
	    gbc_slider.fill = GridBagConstraints.BOTH;
	    gbc_slider.insets = new Insets(0, 0, 0, 5);
	    gbc_slider.gridx = 1;
	    gbc_slider.gridy = 0;
	    panel_pi_h_serve_field_A1.add(slider_pi_h_serve_field_A1, gbc_slider);
	    
	    JLabel label_2 = new JLabel("border");
	    label_2.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_2 = new GridBagConstraints();
	    gbc_label_2.fill = GridBagConstraints.BOTH;
	    gbc_label_2.insets = new Insets(0, 0, 0, 5);
	    gbc_label_2.gridx = 2;
	    gbc_label_2.gridy = 0;
	    panel_pi_h_serve_field_A1.add(label_2, gbc_label_2);
	    
	    label_pi_h_serve_field_A1 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_serve_field_A1 = new GridBagConstraints();
	    gbc_label_pi_h_serve_field_A1.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_serve_field_A1.gridx = 3;
	    gbc_label_pi_h_serve_field_A1.gridy = 0;
	    panel_pi_h_serve_field_A1.add(label_pi_h_serve_field_A1, gbc_label_pi_h_serve_field_A1);
	    }
	    
	    // field field
	    {
	    JPanel panel_pi_h_field_field_A1 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_field_field_A1 = new GridBagConstraints();
	    gbc_panel_pi_h_field_field_A1.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_field_field_A1.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_field_field_A1.gridx = 1;
	    gbc_panel_pi_h_field_field_A1.gridy = 7;
	    pannelYourTeam.add(panel_pi_h_field_field_A1, gbc_panel_pi_h_field_field_A1);
	    GridBagLayout gbl_panel_pi_h_field_field_A1 = new GridBagLayout();
	    gbl_panel_pi_h_field_field_A1.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_field_field_A1.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_field_field_A1.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_field_field_A1.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_field_field_A1.setLayout(gbl_panel_pi_h_field_field_A1);
	    
	    JLabel label_FP = new JLabel("inside");
	    label_FP.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_FP = new GridBagConstraints();
	    gbc_label_FP.fill = GridBagConstraints.BOTH;
	    gbc_label_FP.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FP.gridx = 0;
	    gbc_label_FP.gridy = 0;
	    panel_pi_h_field_field_A1.add(label_FP, gbc_label_FP);
	    
	    slider_pi_h_field_field_A1 = new JSlider();
	    slider_pi_h_field_field_A1.setName("pi_h_field_field_A1_slider");
	    slider_pi_h_field_field_A1.setSnapToTicks(true);
	    slider_pi_h_field_field_A1.setPaintTicks(true);
	    slider_pi_h_field_field_A1.setPaintLabels(true);
	    GridBagConstraints gbc_slider_field_field = new GridBagConstraints();
	    gbc_slider_field_field.fill = GridBagConstraints.BOTH;
	    gbc_slider_field_field.insets = new Insets(0, 0, 0, 5);
	    gbc_slider_field_field.gridx = 1;
	    gbc_slider_field_field.gridy = 0;
	    panel_pi_h_field_field_A1.add(slider_pi_h_field_field_A1, gbc_slider_field_field);
	    
	    JLabel label_FS = new JLabel("border");
	    label_FS.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_FS = new GridBagConstraints();
	    gbc_label_FS.fill = GridBagConstraints.BOTH;
	    gbc_label_FS.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FS.gridx = 2;
	    gbc_label_FS.gridy = 0;
	    panel_pi_h_field_field_A1.add(label_FS, gbc_label_FS);
	    
	    label_pi_h_field_field_A1 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_field_field_A1 = new GridBagConstraints();
	    gbc_label_pi_h_field_field_A1.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_field_field_A1.gridx = 3;
	    gbc_label_pi_h_field_field_A1.gridy = 0;
	    panel_pi_h_field_field_A1.add(label_pi_h_field_field_A1, gbc_label_pi_h_field_field_A1);
	    }
	    
	    // A2
	    // serve-tech
	    {
	    JPanel panel_pi_h_serve_tech_A2 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_serve_tech_A2 = new GridBagConstraints();
	    gbc_panel_pi_h_serve_tech_A2.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_serve_tech_A2.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_serve_tech_A2.gridx = 2;
	    gbc_panel_pi_h_serve_tech_A2.gridy = 4;
	    pannelYourTeam.add(panel_pi_h_serve_tech_A2, gbc_panel_pi_h_serve_tech_A2);
	    GridBagLayout gbl_panel_pi_h_serve_tech_A2 = new GridBagLayout();
	    gbl_panel_pi_h_serve_tech_A2.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_serve_tech_A2.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_serve_tech_A2.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_serve_tech_A2.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_serve_tech_A2.setLayout(gbl_panel_pi_h_serve_tech_A2);
	    
	    JLabel label_1 = new JLabel("SF");
	    label_1.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_1 = new GridBagConstraints();
	    gbc_label_1.fill = GridBagConstraints.BOTH;
	    gbc_label_1.insets = new Insets(0, 0, 0, 5);
	    gbc_label_1.gridx = 0;
	    gbc_label_1.gridy = 0;
	    panel_pi_h_serve_tech_A2.add(label_1, gbc_label_1);
	    
	    slider_pi_h_serve_tech_A2 = new JSlider();
	    slider_pi_h_serve_tech_A2.setName("pi_h_serve_tech_A2_slider");
	    slider_pi_h_serve_tech_A2.setSnapToTicks(true);
	    slider_pi_h_serve_tech_A2.setPaintTicks(true);
	    slider_pi_h_serve_tech_A2.setPaintLabels(true);
	    GridBagConstraints gbc_slider = new GridBagConstraints();
	    gbc_slider.fill = GridBagConstraints.BOTH;
	    gbc_slider.insets = new Insets(0, 0, 0, 5);
	    gbc_slider.gridx = 1;
	    gbc_slider.gridy = 0;
	    panel_pi_h_serve_tech_A2.add(slider_pi_h_serve_tech_A2, gbc_slider);
	    
	    JLabel label_2 = new JLabel("SJ");
	    label_2.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_2 = new GridBagConstraints();
	    gbc_label_2.fill = GridBagConstraints.BOTH;
	    gbc_label_2.insets = new Insets(0, 0, 0, 5);
	    gbc_label_2.gridx = 2;
	    gbc_label_2.gridy = 0;
	    panel_pi_h_serve_tech_A2.add(label_2, gbc_label_2);
	    
	    label_pi_h_serve_tech_A2 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_serve_tech_A2 = new GridBagConstraints();
	    gbc_label_pi_h_serve_tech_A2.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_serve_tech_A2.gridx = 3;
	    gbc_label_pi_h_serve_tech_A2.gridy = 0;
	    panel_pi_h_serve_tech_A2.add(label_pi_h_serve_tech_A2, gbc_label_pi_h_serve_tech_A2);
	    }
	    
	    // field tech
	    {
	    JPanel panel_pi_h_field_tech_A2 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_field_tech_A2 = new GridBagConstraints();
	    gbc_panel_pi_h_field_tech_A2.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_field_tech_A2.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_field_tech_A2.gridx = 2;
	    gbc_panel_pi_h_field_tech_A2.gridy = 6;
	    pannelYourTeam.add(panel_pi_h_field_tech_A2, gbc_panel_pi_h_field_tech_A2);
	    GridBagLayout gbl_panel_pi_h_field_tech_A2 = new GridBagLayout();
	    gbl_panel_pi_h_field_tech_A2.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_field_tech_A2.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_field_tech_A2.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_field_tech_A2.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_field_tech_A2.setLayout(gbl_panel_pi_h_field_tech_A2);
	    
	    JLabel label_FP = new JLabel("FP");
	    label_FP.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_FP = new GridBagConstraints();
	    gbc_label_FP.fill = GridBagConstraints.BOTH;
	    gbc_label_FP.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FP.gridx = 0;
	    gbc_label_FP.gridy = 0;
	    panel_pi_h_field_tech_A2.add(label_FP, gbc_label_FP);
	    
	    slider_pi_h_field_tech_A2 = new JSlider();
	    slider_pi_h_field_tech_A2.setName("pi_h_field_tech_A2_slider");
	    slider_pi_h_field_tech_A2.setSnapToTicks(true);
	    slider_pi_h_field_tech_A2.setPaintTicks(true);
	    slider_pi_h_field_tech_A2.setPaintLabels(true);
	    GridBagConstraints gbc_slider_field_tech = new GridBagConstraints();
	    gbc_slider_field_tech.fill = GridBagConstraints.BOTH;
	    gbc_slider_field_tech.insets = new Insets(0, 0, 0, 5);
	    gbc_slider_field_tech.gridx = 1;
	    gbc_slider_field_tech.gridy = 0;
	    panel_pi_h_field_tech_A2.add(slider_pi_h_field_tech_A2, gbc_slider_field_tech);
	    
	    JLabel label_FS = new JLabel("FS");
	    label_FS.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_FS = new GridBagConstraints();
	    gbc_label_FS.fill = GridBagConstraints.BOTH;
	    gbc_label_FS.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FS.gridx = 2;
	    gbc_label_FS.gridy = 0;
	    panel_pi_h_field_tech_A2.add(label_FS, gbc_label_FS);
	    
	    label_pi_h_field_tech_A2 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_field_tech_A2 = new GridBagConstraints();
	    gbc_label_pi_h_field_tech_A2.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_field_tech_A2.gridx = 3;
	    gbc_label_pi_h_field_tech_A2.gridy = 0;
	    panel_pi_h_field_tech_A2.add(label_pi_h_field_tech_A2, gbc_label_pi_h_field_tech_A2);
	    }
	    
	    // serve-field
	    {
	    JPanel panel_pi_h_serve_field_A2 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_serve_field_A2 = new GridBagConstraints();
	    gbc_panel_pi_h_serve_field_A2.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_serve_field_A2.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_serve_field_A2.gridx = 2;
	    gbc_panel_pi_h_serve_field_A2.gridy = 5;
	    pannelYourTeam.add(panel_pi_h_serve_field_A2, gbc_panel_pi_h_serve_field_A2);
	    GridBagLayout gbl_panel_pi_h_serve_field_A2 = new GridBagLayout();
	    gbl_panel_pi_h_serve_field_A2.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_serve_field_A2.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_serve_field_A2.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_serve_field_A2.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_serve_field_A2.setLayout(gbl_panel_pi_h_serve_field_A2);
	    
	    JLabel label_1 = new JLabel("inside");
	    label_1.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_1 = new GridBagConstraints();
	    gbc_label_1.fill = GridBagConstraints.BOTH;
	    gbc_label_1.insets = new Insets(0, 0, 0, 5);
	    gbc_label_1.gridx = 0;
	    gbc_label_1.gridy = 0;
	    panel_pi_h_serve_field_A2.add(label_1, gbc_label_1);
	    
	    slider_pi_h_serve_field_A2 = new JSlider();
	    slider_pi_h_serve_field_A2.setName("pi_h_serve_field_A2_slider");
	    slider_pi_h_serve_field_A2.setSnapToTicks(true);
	    slider_pi_h_serve_field_A2.setPaintTicks(true);
	    slider_pi_h_serve_field_A2.setPaintLabels(true);
	    GridBagConstraints gbc_slider = new GridBagConstraints();
	    gbc_slider.fill = GridBagConstraints.BOTH;
	    gbc_slider.insets = new Insets(0, 0, 0, 5);
	    gbc_slider.gridx = 1;
	    gbc_slider.gridy = 0;
	    panel_pi_h_serve_field_A2.add(slider_pi_h_serve_field_A2, gbc_slider);
	    
	    JLabel label_2 = new JLabel("border");
	    label_2.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_2 = new GridBagConstraints();
	    gbc_label_2.fill = GridBagConstraints.BOTH;
	    gbc_label_2.insets = new Insets(0, 0, 0, 5);
	    gbc_label_2.gridx = 2;
	    gbc_label_2.gridy = 0;
	    panel_pi_h_serve_field_A2.add(label_2, gbc_label_2);
	    
	    label_pi_h_serve_field_A2 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_serve_field_A2 = new GridBagConstraints();
	    gbc_label_pi_h_serve_field_A2.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_serve_field_A2.gridx = 3;
	    gbc_label_pi_h_serve_field_A2.gridy = 0;
	    panel_pi_h_serve_field_A2.add(label_pi_h_serve_field_A2, gbc_label_pi_h_serve_field_A2);
	    }
	    
	    // field field
	    {
	    JPanel panel_pi_h_field_field_A2 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_field_field_A2 = new GridBagConstraints();
	    gbc_panel_pi_h_field_field_A2.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_field_field_A2.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_field_field_A2.gridx = 2;
	    gbc_panel_pi_h_field_field_A2.gridy = 7;
	    pannelYourTeam.add(panel_pi_h_field_field_A2, gbc_panel_pi_h_field_field_A2);
	    GridBagLayout gbl_panel_pi_h_field_field_A2 = new GridBagLayout();
	    gbl_panel_pi_h_field_field_A2.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_field_field_A2.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_field_field_A2.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_field_field_A2.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_field_field_A2.setLayout(gbl_panel_pi_h_field_field_A2);
	    
	    JLabel label_FP = new JLabel("inside");
	    label_FP.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_FP = new GridBagConstraints();
	    gbc_label_FP.fill = GridBagConstraints.BOTH;
	    gbc_label_FP.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FP.gridx = 0;
	    gbc_label_FP.gridy = 0;
	    panel_pi_h_field_field_A2.add(label_FP, gbc_label_FP);
	    
	    slider_pi_h_field_field_A2 = new JSlider();
	    slider_pi_h_field_field_A2.setName("pi_h_field_field_A2_slider");
	    slider_pi_h_field_field_A2.setSnapToTicks(true);
	    slider_pi_h_field_field_A2.setPaintTicks(true);
	    slider_pi_h_field_field_A2.setPaintLabels(true);
	    GridBagConstraints gbc_slider_field_field = new GridBagConstraints();
	    gbc_slider_field_field.fill = GridBagConstraints.BOTH;
	    gbc_slider_field_field.insets = new Insets(0, 0, 0, 5);
	    gbc_slider_field_field.gridx = 1;
	    gbc_slider_field_field.gridy = 0;
	    panel_pi_h_field_field_A2.add(slider_pi_h_field_field_A2, gbc_slider_field_field);
	    
	    JLabel label_FS = new JLabel("border");
	    label_FS.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_FS = new GridBagConstraints();
	    gbc_label_FS.fill = GridBagConstraints.BOTH;
	    gbc_label_FS.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FS.gridx = 2;
	    gbc_label_FS.gridy = 0;
	    panel_pi_h_field_field_A2.add(label_FS, gbc_label_FS);
	    
	    label_pi_h_field_field_A2 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_field_field_A2 = new GridBagConstraints();
	    gbc_label_pi_h_field_field_A2.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_field_field_A2.gridx = 3;
	    gbc_label_pi_h_field_field_A2.gridy = 0;
	    panel_pi_h_field_field_A2.add(label_pi_h_field_field_A2, gbc_label_pi_h_field_field_A2);
	    }
	    
	    
	    pannelYourTeam.add(Box.createVerticalStrut(5));
	    pannelYourTeam.add(new JSeparator(SwingConstants.HORIZONTAL));
	    pannelYourTeam.add(Box.createVerticalStrut(5));
	    
	    // block
	    {
	    JPanel panel_pi_b = new JPanel();
	    GridBagConstraints gbc_panel_pi_b = new GridBagConstraints();
	    gbc_panel_pi_b.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_b.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_b.gridx = 2;
	    gbc_panel_pi_b.gridy = 8;
	    pannelYourTeam.add(panel_pi_b, gbc_panel_pi_b);
	    GridBagLayout gbl_panel_pi_b = new GridBagLayout();
	    gbl_panel_pi_b.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_b.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_b.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_b.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_b.setLayout(gbl_panel_pi_b);
	    
	    JLabel label_FP = new JLabel("A1");
	    label_FP.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_FP = new GridBagConstraints();
	    gbc_label_FP.fill = GridBagConstraints.BOTH;
	    gbc_label_FP.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FP.gridx = 0;
	    gbc_label_FP.gridy = 1;
	    panel_pi_b.add(label_FP, gbc_label_FP);
	    
	    slider_pi_b = new JSlider();
	    slider_pi_b.setName("pi_b_slider");
	    slider_pi_b.setSnapToTicks(true);
	    slider_pi_b.setPaintTicks(true);
	    slider_pi_b.setPaintLabels(true);
	    GridBagConstraints gbc_slider_field_field = new GridBagConstraints();
	    gbc_slider_field_field.fill = GridBagConstraints.BOTH;
	    gbc_slider_field_field.insets = new Insets(0, 0, 0, 5);
	    gbc_slider_field_field.gridx = 1;
	    gbc_slider_field_field.gridy = 1;
	    panel_pi_b.add(slider_pi_b, gbc_slider_field_field);
	    
	    GridBagConstraints gbc_block = new GridBagConstraints();
	    gbc_block.fill = GridBagConstraints.BOTH;
	    gbc_block.insets = new Insets(0, 0, 0, 5);
	    gbc_block.gridx = 0;
	    gbc_block.gridy = 0;
	    panel_pi_b.add(new JLabel("Block:"), gbc_block);
	    
	    JLabel label_FS = new JLabel("A2");
	    label_FS.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_FS = new GridBagConstraints();
	    gbc_label_FS.fill = GridBagConstraints.BOTH;
	    gbc_label_FS.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FS.gridx = 2;
	    gbc_label_FS.gridy = 1;
	    panel_pi_b.add(label_FS, gbc_label_FS);
	    
	    label_pi_b = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_b = new GridBagConstraints();
	    gbc_label_pi_b.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_b.gridx = 3;
	    gbc_label_pi_b.gridy = 1;
	    panel_pi_b.add(label_pi_b, gbc_label_pi_b);
	    }
	    
	    // block
	    {
	    JPanel panel_pi_s = new JPanel();
	    GridBagConstraints gbc_panel_pi_s = new GridBagConstraints();
	    gbc_panel_pi_s.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_s.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_s.gridx = 1;
	    gbc_panel_pi_s.gridy = 8;
	    pannelYourTeam.add(panel_pi_s, gbc_panel_pi_s);
	    GridBagLayout gbl_panel_pi_s = new GridBagLayout();
	    gbl_panel_pi_s.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_s.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_s.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_s.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_s.setLayout(gbl_panel_pi_s);
	    
	    JLabel label_FP = new JLabel("B1");
	    label_FP.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_FP = new GridBagConstraints();
	    gbc_label_FP.fill = GridBagConstraints.BOTH;
	    gbc_label_FP.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FP.gridx = 0;
	    gbc_label_FP.gridy = 1;
	    panel_pi_s.add(label_FP, gbc_label_FP);
	    
	    slider_pi_s = new JSlider();
	    slider_pi_s.setName("pi_s_slider");
	    slider_pi_s.setSnapToTicks(true);
	    slider_pi_s.setPaintTicks(true);
	    slider_pi_s.setPaintLabels(true);
	    GridBagConstraints gbc_slider_field_field = new GridBagConstraints();
	    gbc_slider_field_field.fill = GridBagConstraints.BOTH;
	    gbc_slider_field_field.insets = new Insets(0, 0, 0, 5);
	    gbc_slider_field_field.gridx = 1;
	    gbc_slider_field_field.gridy = 1;
	    panel_pi_s.add(slider_pi_s, gbc_slider_field_field);
	    
	    GridBagConstraints gbc_slock = new GridBagConstraints();
	    gbc_slock.fill = GridBagConstraints.BOTH;
	    gbc_slock.insets = new Insets(0, 0, 0, 5);
	    gbc_slock.gridx = 0;
	    gbc_slock.gridy = 0;
	    panel_pi_s.add(new JLabel("Serve:"), gbc_slock);
	    
	    JLabel label_FS = new JLabel("B2");
	    label_FS.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_FS = new GridBagConstraints();
	    gbc_label_FS.fill = GridBagConstraints.BOTH;
	    gbc_label_FS.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FS.gridx = 2;
	    gbc_label_FS.gridy = 1;
	    panel_pi_s.add(label_FS, gbc_label_FS);
	    
	    label_pi_s = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_s = new GridBagConstraints();
	    gbc_label_pi_s.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_s.gridx = 3;
	    gbc_label_pi_s.gridy = 1;
	    panel_pi_s.add(label_pi_s, gbc_label_pi_s);
	    }
	    
	    
	    JButton btnReset = new JButton("Reset");
	    btnReset.setToolTipText("Reset to basic strat");
	    GridBagConstraints gbc_btnReset = new GridBagConstraints();
	    gbc_btnReset.insets = new Insets(0, 0, 5, 0);
	    gbc_btnReset.gridx = 3;
	    gbc_btnReset.gridy = 8;
	    pannelYourTeam.add(btnReset, gbc_btnReset);
	    
	    JButton btnRisky = new JButton("Risky");
	    btnReset.setToolTipText("Set to risky Strat");
	    GridBagConstraints gbc_btnRisky = new GridBagConstraints();
	    gbc_btnRisky.insets = new Insets(0, 0, 5, 0);
	    gbc_btnRisky.gridx = 3;
	    gbc_btnRisky.gridy = 7;
	    pannelYourTeam.add(btnRisky, gbc_btnRisky);
	    
	    JButton btnSafe = new JButton("Safe");
	    btnReset.setToolTipText("Set to risky Strat");
	    GridBagConstraints gbc_btnSafe = new GridBagConstraints();
	    gbc_btnSafe.insets = new Insets(0, 0, 5, 0);
	    gbc_btnSafe.gridx = 3;
	    gbc_btnSafe.gridy = 6;
	    pannelYourTeam.add(btnSafe, gbc_btnSafe);
	    
	    btnReset.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				label_pi_h_serve_tech_A1.setText("0.5");
				label_pi_h_serve_field_A1.setText("0.5");
				label_pi_h_field_tech_A1.setText("0.5");
				label_pi_h_field_field_A1.setText("0.5");
				label_pi_h_serve_tech_A2.setText("0.5");
				label_pi_h_serve_field_A2.setText("0.5");
				label_pi_h_field_tech_A2.setText("0.5");
				label_pi_h_field_field_A2.setText("0.5");
				label_pi_b.setText("0.5");
				label_pi_s.setText("0.5");
				
				slider_pi_h_serve_tech_A1.setValue(50);
				slider_pi_h_serve_field_A1.setValue(50);
				slider_pi_h_field_tech_A1.setValue(50);
				slider_pi_h_field_field_A1.setValue(50);
				slider_pi_h_serve_tech_A2.setValue(50);
				slider_pi_h_serve_field_A2.setValue(50);
				slider_pi_h_field_tech_A2.setValue(50);
				slider_pi_h_field_field_A2.setValue(50);
				
				slider_pi_b.setValue(50);
				slider_pi_s.setValue(50);
			}
	    });
	    
	    btnRisky.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				label_pi_h_serve_tech_A1.setText("1.0");
				label_pi_h_serve_field_A1.setText("1.0");
				label_pi_h_field_tech_A1.setText("1.0");
				label_pi_h_field_field_A1.setText("1.0");
				label_pi_h_serve_tech_A2.setText("1.0");
				label_pi_h_serve_field_A2.setText("1.0");
				label_pi_h_field_tech_A2.setText("1.0");
				label_pi_h_field_field_A2.setText("1.0");
				label_pi_b.setText("1.0");
				label_pi_s.setText("1.0");
				
				slider_pi_h_serve_tech_A1.setValue(100);
				slider_pi_h_serve_field_A1.setValue(100);
				slider_pi_h_field_tech_A1.setValue(100);
				slider_pi_h_field_field_A1.setValue(100);
				slider_pi_h_serve_tech_A2.setValue(100);
				slider_pi_h_serve_field_A2.setValue(100);
				slider_pi_h_field_tech_A2.setValue(100);
				slider_pi_h_field_field_A2.setValue(100);
				
				slider_pi_b.setValue(100);
				slider_pi_s.setValue(100);
			}
	    });
	    
	    btnSafe.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				label_pi_h_serve_tech_A1.setText("0.0");
				label_pi_h_serve_field_A1.setText("0.0");
				label_pi_h_field_tech_A1.setText("0.0");
				label_pi_h_field_field_A1.setText("0.0");
				label_pi_h_serve_tech_A2.setText("0.0");
				label_pi_h_serve_field_A2.setText("0.0");
				label_pi_h_field_tech_A2.setText("0.0");
				label_pi_h_field_field_A2.setText("0.0");
				label_pi_b.setText("0.0");
				label_pi_s.setText("0.0");
				
				slider_pi_h_serve_tech_A1.setValue(0);
				slider_pi_h_serve_field_A1.setValue(0);
				slider_pi_h_field_tech_A1.setValue(0);
				slider_pi_h_field_field_A1.setValue(0);
				slider_pi_h_serve_tech_A2.setValue(0);
				slider_pi_h_serve_field_A2.setValue(0);
				slider_pi_h_field_tech_A2.setValue(0);
				slider_pi_h_field_field_A2.setValue(0);
				
				slider_pi_b.setValue(0);
				slider_pi_s.setValue(0);
			}
	    });
	    
	    /**
	     * change listener
	     */
	    ChangeListener changelistener = new ChangeListener() {
	    	public void stateChanged(ChangeEvent e) {
	    		JSlider source = (JSlider)e.getSource();
	    		double d = 0.0;
	    		d = source.getValue()*1.0/100;
	    		if (source.getName()=="pi_h_serve_tech_A1_slider")
	    			label_pi_h_serve_tech_A1.setText(d + "");
	    		if (source.getName()=="pi_h_field_tech_A1_slider")
	    			label_pi_h_field_tech_A1.setText(d + "");
	    		if (source.getName()=="pi_h_serve_field_A1_slider")
	    			label_pi_h_serve_field_A1.setText(d + "");
	    		if (source.getName()=="pi_h_field_field_A1_slider")
	    			label_pi_h_field_field_A1.setText(d + "");
	    		if (source.getName()=="pi_h_serve_tech_A2_slider")
	    			label_pi_h_serve_tech_A2.setText(d + "");
	    		if (source.getName()=="pi_h_field_tech_A2_slider")
    			label_pi_h_field_tech_A2.setText(d + "");
	    		if (source.getName()=="pi_h_serve_field_A2_slider")
	    			label_pi_h_serve_field_A2.setText(d + "");
	    		if (source.getName()=="pi_h_field_field_A2_slider")
    			label_pi_h_field_field_A2.setText(d + "");
	    		if (source.getName()=="pi_b_slider")
	    			label_pi_b.setText(d + "");
	    		if (source.getName()=="pi_s_slider")
    			label_pi_s.setText(d + "");
	    	}
	    };
	    
	    slider_pi_h_serve_tech_A1.addChangeListener(changelistener);
	    slider_pi_h_field_tech_A1.addChangeListener(changelistener);
	    slider_pi_h_serve_tech_A2.addChangeListener(changelistener);
	    slider_pi_h_field_tech_A2.addChangeListener(changelistener);
	    slider_pi_h_serve_field_A1.addChangeListener(changelistener);
	    slider_pi_h_field_field_A1.addChangeListener(changelistener);
	    slider_pi_h_serve_field_A2.addChangeListener(changelistener);
	    slider_pi_h_field_field_A2.addChangeListener(changelistener);
	    slider_pi_b.addChangeListener(changelistener);
	    slider_pi_s.addChangeListener(changelistener);
	    	    
	    ///////////////////////////////////////////////
	    JPanel pannelOpponent = new JPanel();
	    ///////////////////////////////////////////////
	    this.addTab("Opponent Team", pannelOpponent);
	    
	    GridBagLayout gbl_pannelOpponent = new GridBagLayout();
	    gbl_pannelOpponent.columnWidths = new int[] {0, 0, 0, 0, 0};
	    gbl_pannelOpponent.rowHeights = new int[]{30, 0, 0, 0, 30, 0};
	    gbl_pannelOpponent.columnWeights = new double[]{0.0, 1.0, 0.0, 1.0, 0.0};
	    gbl_pannelOpponent.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 1.0, Double.MIN_VALUE};
	    pannelOpponent.setLayout(gbl_pannelOpponent);
	    
	    JLabel lblTeamName = new JLabel("Team Name");
	    GridBagConstraints gbc_lblTeamName = new GridBagConstraints();
	    gbc_lblTeamName.insets = new Insets(0, 0, 5, 5);
	    gbc_lblTeamName.gridx = 1;
	    gbc_lblTeamName.gridy = 1;
	    pannelOpponent.add(lblTeamName, gbc_lblTeamName);
	    
	    txt_teamB = new JTextField("Brazil");
	    txt_teamB.setHorizontalAlignment(SwingConstants.CENTER);
	    txt_teamB.setToolTipText("Team B");
	    GridBagConstraints gbc_txtFrance = new GridBagConstraints();
	    gbc_txtFrance.insets = new Insets(0, 0, 5, 5);
	    gbc_txtFrance.fill = GridBagConstraints.HORIZONTAL;
	    gbc_txtFrance.gridx = 2;
	    gbc_txtFrance.gridy = 1;
	    pannelOpponent.add(txt_teamB, gbc_txtFrance);
	    txt_teamB.setColumns(10);
	    
	    txt_skillsTeamB = new JTextField("data/BRA/allMatchesExceptFinal/BRA_allMatchesExceptFinal.gprobs.csv");
	    txt_skillsTeamB.setHorizontalAlignment(SwingConstants.CENTER);
	    txt_skillsTeamB.setToolTipText("Skills Team B");
		GridBagConstraints gbc_txt_q2 = new GridBagConstraints();
		gbc_txt_q2.insets = new Insets(0, 0, 5, 5);
		gbc_txt_q2.fill = GridBagConstraints.HORIZONTAL;
		gbc_txt_q2.gridx = 2;
		gbc_txt_q2.gridy = 2;
		pannelOpponent.add(txt_skillsTeamB, gbc_txt_q2);
		txt_skillsTeamB.setColumns(10);
		
		JLabel lblTeamName_SkillsB = new JLabel("Skills");
		GridBagConstraints gbc_lblTeamName_SkillsB = new GridBagConstraints();
		gbc_lblTeamName_SkillsB.insets = new Insets(0, 0, 5, 5);
		gbc_lblTeamName_SkillsB.gridx = 1;
		gbc_lblTeamName_SkillsB.gridy = 2;
		pannelOpponent.add(lblTeamName_SkillsB, gbc_lblTeamName_SkillsB);

	    
	    JButton btnSearchB = new JButton("Search...");
	    btnSearchB.setToolTipText("Search Skill Data File Team B");
	    GridBagConstraints gbc_btnSearchB = new GridBagConstraints();
	    gbc_btnSearchB.insets = new Insets(0, 0, 5, 0);
	    gbc_btnSearchB.gridx = 3;
	    gbc_btnSearchB.gridy = 2;
	    pannelOpponent.add(btnSearchB, gbc_btnSearchB);
	    
	    btnSearchB.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				int returnVal = fc.showOpenDialog(EditPane.this);
				 
	            if (returnVal == JFileChooser.APPROVE_OPTION) {
	                File file = fc.getSelectedFile();
	                txt_skillsTeamB.setText(file.getPath());
	                try {
	                	txt_skillsTeamB.setText(file.getCanonicalPath());
						System.out.println("Opening: " + file.getCanonicalPath());
					} catch (IOException e) {
						e.printStackTrace();
					}
	            } else {
	            	System.out.println("Open command cancelled by user.");
	            }
			}
	    });
		
	    JPanel panelPlayerB1 = new JPanel();
	    panelPlayerB1.setBorder(new TitledBorder(null, "Player 1", TitledBorder.LEADING, TitledBorder.TOP, null, null));
	    GridBagConstraints gbc_panelPlayerB1 = new GridBagConstraints();
	    gbc_panelPlayerB1.insets = new Insets(0, 0, 5, 5);
	    gbc_panelPlayerB1.fill = GridBagConstraints.BOTH;
	    gbc_panelPlayerB1.gridx = 1;
	    gbc_panelPlayerB1.gridy = 3;
	    pannelOpponent.add(panelPlayerB1, gbc_panelPlayerB1);
	    GridBagLayout gbl_panelPlayerB1 = new GridBagLayout();
	    gbl_panelPlayerB1.columnWidths = new int[]{0, 0, 0};
	    gbl_panelPlayerB1.rowHeights = new int[]{0, 0, 0};
	    gbl_panelPlayerB1.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
	    gbl_panelPlayerB1.rowWeights = new double[]{0.0, 0.0, Double.MIN_VALUE};
	    panelPlayerB1.setLayout(gbl_panelPlayerB1);
	    
	    JLabel label = new JLabel("Name");
	    GridBagConstraints gbc_label = new GridBagConstraints();
	    gbc_label.anchor = GridBagConstraints.EAST;
	    gbc_label.insets = new Insets(0, 0, 5, 5);
	    gbc_label.gridx = 0;
	    gbc_label.gridy = 0;
	    panelPlayerB1.add(label, gbc_label);
	    
	    txt_nameB1 = new JTextField("Alison");
	    txt_nameB1.setColumns(10);
	    GridBagConstraints gbc_txtPlayerB1 = new GridBagConstraints();
	    gbc_txtPlayerB1.fill = GridBagConstraints.HORIZONTAL;
	    gbc_txtPlayerB1.insets = new Insets(0, 0, 5, 0);
	    gbc_txtPlayerB1.gridx = 1;
	    gbc_txtPlayerB1.gridy = 0;
	    panelPlayerB1.add(txt_nameB1, gbc_txtPlayerB1);
	   
	    
	    JPanel panelPlayerB2 = new JPanel();
	    panelPlayerB2.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED, null, null), "Player 2", TitledBorder.LEADING, TitledBorder.TOP, null, new Color(0, 0, 0)));
	    GridBagConstraints gbc_panelPlayerB2 = new GridBagConstraints();
	    gbc_panelPlayerB2.insets = new Insets(0, 0, 5, 5);
	    gbc_panelPlayerB2.fill = GridBagConstraints.BOTH;
	    gbc_panelPlayerB2.gridx = 2;
	    gbc_panelPlayerB2.gridy = 3;
	    pannelOpponent.add(panelPlayerB2, gbc_panelPlayerB2);
	    GridBagLayout gbl_panelPlayerB2 = new GridBagLayout();
	    gbl_panelPlayerB2.columnWidths = new int[]{0, 0, 0};
	    gbl_panelPlayerB2.rowHeights = new int[]{0, 0, 0};
	    gbl_panelPlayerB2.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
	    gbl_panelPlayerB2.rowWeights = new double[]{0.0, 0.0, Double.MIN_VALUE};
	    panelPlayerB2.setLayout(gbl_panelPlayerB2);
	    
	    JLabel label_2 = new JLabel("Name");
	    GridBagConstraints gbc_label_2 = new GridBagConstraints();
	    gbc_label_2.anchor = GridBagConstraints.EAST;
	    gbc_label_2.insets = new Insets(0, 0, 5, 5);
	    gbc_label_2.gridx = 0;
	    gbc_label_2.gridy = 0;
	    panelPlayerB2.add(label_2, gbc_label_2);
	    
	    txt_nameB2 = new JTextField("Emanuel");
	    txt_nameB2.setColumns(10);
	    GridBagConstraints gbc_txtPlayerB2 = new GridBagConstraints();
	    gbc_txtPlayerB2.fill = GridBagConstraints.HORIZONTAL;
	    gbc_txtPlayerB2.insets = new Insets(0, 0, 5, 0);
	    gbc_txtPlayerB2.gridx = 1;
	    gbc_txtPlayerB2.gridy = 0;
	    panelPlayerB2.add(txt_nameB2, gbc_txtPlayerB2);
	    
	    /**
	     * sliders for strat
	     */
	    // serve-tech
	    {
	    JPanel panel_pi_h_serve_tech_B1 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_serve_tech_B1 = new GridBagConstraints();
	    gbc_panel_pi_h_serve_tech_B1.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_serve_tech_B1.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_serve_tech_B1.gridx = 1;
	    gbc_panel_pi_h_serve_tech_B1.gridy = 4;
	    pannelOpponent.add(panel_pi_h_serve_tech_B1, gbc_panel_pi_h_serve_tech_B1);
	    GridBagLayout gbl_panel_pi_h_serve_tech_B1 = new GridBagLayout();
	    gbl_panel_pi_h_serve_tech_B1.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_serve_tech_B1.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_serve_tech_B1.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_serve_tech_B1.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_serve_tech_B1.setLayout(gbl_panel_pi_h_serve_tech_B1);
	    
	    JLabel label_1 = new JLabel("SF");
	    label_1.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_1 = new GridBagConstraints();
	    gbc_label_1.fill = GridBagConstraints.BOTH;
	    gbc_label_1.insets = new Insets(0, 0, 0, 5);
	    gbc_label_1.gridx = 0;
	    gbc_label_1.gridy = 0;
	    panel_pi_h_serve_tech_B1.add(label_1, gbc_label_1);
	    
	    slider_pi_h_serve_tech_B1 = new JSlider();
	    slider_pi_h_serve_tech_B1.setName("pi_h_serve_tech_B1_slider");
	    slider_pi_h_serve_tech_B1.setSnapToTicks(true);
	    slider_pi_h_serve_tech_B1.setPaintTicks(true);
	    slider_pi_h_serve_tech_B1.setPaintLabels(true);
	    GridBagConstraints gbc_slider = new GridBagConstraints();
	    gbc_slider.fill = GridBagConstraints.BOTH;
	    gbc_slider.insets = new Insets(0, 0, 0, 5);
	    gbc_slider.gridx = 1;
	    gbc_slider.gridy = 0;
	    panel_pi_h_serve_tech_B1.add(slider_pi_h_serve_tech_B1, gbc_slider);
	    
	    label_2 = new JLabel("SJ");
	    label_2.setHorizontalAlignment(SwingConstants.LEFT);
	    gbc_label_2 = new GridBagConstraints();
	    gbc_label_2.fill = GridBagConstraints.BOTH;
	    gbc_label_2.insets = new Insets(0, 0, 0, 5);
	    gbc_label_2.gridx = 2;
	    gbc_label_2.gridy = 0;
	    panel_pi_h_serve_tech_B1.add(label_2, gbc_label_2);
	    
	    label_pi_h_serve_tech_B1 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_serve_tech_B1 = new GridBagConstraints();
	    gbc_label_pi_h_serve_tech_B1.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_serve_tech_B1.gridx = 3;
	    gbc_label_pi_h_serve_tech_B1.gridy = 0;
	    panel_pi_h_serve_tech_B1.add(label_pi_h_serve_tech_B1, gbc_label_pi_h_serve_tech_B1);
	    }
	    
	    // field tech
	    {
	    JPanel panel_pi_h_field_tech_B1 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_field_tech_B1 = new GridBagConstraints();
	    gbc_panel_pi_h_field_tech_B1.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_field_tech_B1.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_field_tech_B1.gridx = 1;
	    gbc_panel_pi_h_field_tech_B1.gridy = 6;
	    pannelOpponent.add(panel_pi_h_field_tech_B1, gbc_panel_pi_h_field_tech_B1);
	    GridBagLayout gbl_panel_pi_h_field_tech_B1 = new GridBagLayout();
	    gbl_panel_pi_h_field_tech_B1.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_field_tech_B1.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_field_tech_B1.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_field_tech_B1.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_field_tech_B1.setLayout(gbl_panel_pi_h_field_tech_B1);
	    
	    JLabel label_FP = new JLabel("FP");
	    label_FP.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_FP = new GridBagConstraints();
	    gbc_label_FP.fill = GridBagConstraints.BOTH;
	    gbc_label_FP.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FP.gridx = 0;
	    gbc_label_FP.gridy = 0;
	    panel_pi_h_field_tech_B1.add(label_FP, gbc_label_FP);
	    
	    slider_pi_h_field_tech_B1 = new JSlider();
	    slider_pi_h_field_tech_B1.setName("pi_h_field_tech_B1_slider");
	    slider_pi_h_field_tech_B1.setSnapToTicks(true);
	    slider_pi_h_field_tech_B1.setPaintTicks(true);
	    slider_pi_h_field_tech_B1.setPaintLabels(true);
	    GridBagConstraints gbc_slider_field_tech = new GridBagConstraints();
	    gbc_slider_field_tech.fill = GridBagConstraints.BOTH;
	    gbc_slider_field_tech.insets = new Insets(0, 0, 0, 5);
	    gbc_slider_field_tech.gridx = 1;
	    gbc_slider_field_tech.gridy = 0;
	    panel_pi_h_field_tech_B1.add(slider_pi_h_field_tech_B1, gbc_slider_field_tech);
	    
	    JLabel label_FS = new JLabel("FS");
	    label_FS.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_FS = new GridBagConstraints();
	    gbc_label_FS.fill = GridBagConstraints.BOTH;
	    gbc_label_FS.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FS.gridx = 2;
	    gbc_label_FS.gridy = 0;
	    panel_pi_h_field_tech_B1.add(label_FS, gbc_label_FS);
	    
	    label_pi_h_field_tech_B1 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_field_tech_B1 = new GridBagConstraints();
	    gbc_label_pi_h_field_tech_B1.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_field_tech_B1.gridx = 3;
	    gbc_label_pi_h_field_tech_B1.gridy = 0;
	    panel_pi_h_field_tech_B1.add(label_pi_h_field_tech_B1, gbc_label_pi_h_field_tech_B1);
	    }
	    
	    // serve-field
	    {
	    JPanel panel_pi_h_serve_field_B1 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_serve_field_B1 = new GridBagConstraints();
	    gbc_panel_pi_h_serve_field_B1.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_serve_field_B1.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_serve_field_B1.gridx = 1;
	    gbc_panel_pi_h_serve_field_B1.gridy = 5;
	    pannelOpponent.add(panel_pi_h_serve_field_B1, gbc_panel_pi_h_serve_field_B1);
	    GridBagLayout gbl_panel_pi_h_serve_field_B1 = new GridBagLayout();
	    gbl_panel_pi_h_serve_field_B1.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_serve_field_B1.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_serve_field_B1.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_serve_field_B1.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_serve_field_B1.setLayout(gbl_panel_pi_h_serve_field_B1);
	    
	    JLabel label_1 = new JLabel("inside");
	    label_1.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_1 = new GridBagConstraints();
	    gbc_label_1.fill = GridBagConstraints.BOTH;
	    gbc_label_1.insets = new Insets(0, 0, 0, 5);
	    gbc_label_1.gridx = 0;
	    gbc_label_1.gridy = 0;
	    panel_pi_h_serve_field_B1.add(label_1, gbc_label_1);
	    
	    slider_pi_h_serve_field_B1 = new JSlider();
	    slider_pi_h_serve_field_B1.setName("pi_h_serve_field_B1_slider");
	    slider_pi_h_serve_field_B1.setSnapToTicks(true);
	    slider_pi_h_serve_field_B1.setPaintTicks(true);
	    slider_pi_h_serve_field_B1.setPaintLabels(true);
	    GridBagConstraints gbc_slider = new GridBagConstraints();
	    gbc_slider.fill = GridBagConstraints.BOTH;
	    gbc_slider.insets = new Insets(0, 0, 0, 5);
	    gbc_slider.gridx = 1;
	    gbc_slider.gridy = 0;
	    panel_pi_h_serve_field_B1.add(slider_pi_h_serve_field_B1, gbc_slider);
	    
	    label_2 = new JLabel("border");
	    label_2.setHorizontalAlignment(SwingConstants.LEFT);
	    gbc_label_2 = new GridBagConstraints();
	    gbc_label_2.fill = GridBagConstraints.BOTH;
	    gbc_label_2.insets = new Insets(0, 0, 0, 5);
	    gbc_label_2.gridx = 2;
	    gbc_label_2.gridy = 0;
	    panel_pi_h_serve_field_B1.add(label_2, gbc_label_2);
	    
	    label_pi_h_serve_field_B1 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_serve_field_B1 = new GridBagConstraints();
	    gbc_label_pi_h_serve_field_B1.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_serve_field_B1.gridx = 3;
	    gbc_label_pi_h_serve_field_B1.gridy = 0;
	    panel_pi_h_serve_field_B1.add(label_pi_h_serve_field_B1, gbc_label_pi_h_serve_field_B1);
	    }
	    
	    // field field
	    {
	    JPanel panel_pi_h_field_field_B1 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_field_field_B1 = new GridBagConstraints();
	    gbc_panel_pi_h_field_field_B1.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_field_field_B1.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_field_field_B1.gridx = 1;
	    gbc_panel_pi_h_field_field_B1.gridy = 7;
	    pannelOpponent.add(panel_pi_h_field_field_B1, gbc_panel_pi_h_field_field_B1);
	    GridBagLayout gbl_panel_pi_h_field_field_B1 = new GridBagLayout();
	    gbl_panel_pi_h_field_field_B1.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_field_field_B1.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_field_field_B1.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_field_field_B1.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_field_field_B1.setLayout(gbl_panel_pi_h_field_field_B1);
	    
	    JLabel label_FP = new JLabel("inside");
	    label_FP.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_FP = new GridBagConstraints();
	    gbc_label_FP.fill = GridBagConstraints.BOTH;
	    gbc_label_FP.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FP.gridx = 0;
	    gbc_label_FP.gridy = 0;
	    panel_pi_h_field_field_B1.add(label_FP, gbc_label_FP);
	    
	    slider_pi_h_field_field_B1 = new JSlider();
	    slider_pi_h_field_field_B1.setName("pi_h_field_field_B1_slider");
	    slider_pi_h_field_field_B1.setSnapToTicks(true);
	    slider_pi_h_field_field_B1.setPaintTicks(true);
	    slider_pi_h_field_field_B1.setPaintLabels(true);
	    GridBagConstraints gbc_slider_field_field = new GridBagConstraints();
	    gbc_slider_field_field.fill = GridBagConstraints.BOTH;
	    gbc_slider_field_field.insets = new Insets(0, 0, 0, 5);
	    gbc_slider_field_field.gridx = 1;
	    gbc_slider_field_field.gridy = 0;
	    panel_pi_h_field_field_B1.add(slider_pi_h_field_field_B1, gbc_slider_field_field);
	    
	    JLabel label_FS = new JLabel("border");
	    label_FS.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_FS = new GridBagConstraints();
	    gbc_label_FS.fill = GridBagConstraints.BOTH;
	    gbc_label_FS.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FS.gridx = 2;
	    gbc_label_FS.gridy = 0;
	    panel_pi_h_field_field_B1.add(label_FS, gbc_label_FS);
	    
	    label_pi_h_field_field_B1 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_field_field_B1 = new GridBagConstraints();
	    gbc_label_pi_h_field_field_B1.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_field_field_B1.gridx = 3;
	    gbc_label_pi_h_field_field_B1.gridy = 0;
	    panel_pi_h_field_field_B1.add(label_pi_h_field_field_B1, gbc_label_pi_h_field_field_B1);
	    }
	    
	    // B2
	    // serve-tech
	    {
	    JPanel panel_pi_h_serve_tech_B2 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_serve_tech_B2 = new GridBagConstraints();
	    gbc_panel_pi_h_serve_tech_B2.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_serve_tech_B2.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_serve_tech_B2.gridx = 2;
	    gbc_panel_pi_h_serve_tech_B2.gridy = 4;
	    pannelOpponent.add(panel_pi_h_serve_tech_B2, gbc_panel_pi_h_serve_tech_B2);
	    GridBagLayout gbl_panel_pi_h_serve_tech_B2 = new GridBagLayout();
	    gbl_panel_pi_h_serve_tech_B2.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_serve_tech_B2.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_serve_tech_B2.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_serve_tech_B2.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_serve_tech_B2.setLayout(gbl_panel_pi_h_serve_tech_B2);
	    
	    JLabel label_1 = new JLabel("SF");
	    label_1.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_1 = new GridBagConstraints();
	    gbc_label_1.fill = GridBagConstraints.BOTH;
	    gbc_label_1.insets = new Insets(0, 0, 0, 5);
	    gbc_label_1.gridx = 0;
	    gbc_label_1.gridy = 0;
	    panel_pi_h_serve_tech_B2.add(label_1, gbc_label_1);
	    
	    slider_pi_h_serve_tech_B2 = new JSlider();
	    slider_pi_h_serve_tech_B2.setName("pi_h_serve_tech_B2_slider");
	    slider_pi_h_serve_tech_B2.setSnapToTicks(true);
	    slider_pi_h_serve_tech_B2.setPaintTicks(true);
	    slider_pi_h_serve_tech_B2.setPaintLabels(true);
	    GridBagConstraints gbc_slider = new GridBagConstraints();
	    gbc_slider.fill = GridBagConstraints.BOTH;
	    gbc_slider.insets = new Insets(0, 0, 0, 5);
	    gbc_slider.gridx = 1;
	    gbc_slider.gridy = 0;
	    panel_pi_h_serve_tech_B2.add(slider_pi_h_serve_tech_B2, gbc_slider);
	    
	    label_2 = new JLabel("SJ");
	    label_2.setHorizontalAlignment(SwingConstants.LEFT);
	    gbc_label_2 = new GridBagConstraints();
	    gbc_label_2.fill = GridBagConstraints.BOTH;
	    gbc_label_2.insets = new Insets(0, 0, 0, 5);
	    gbc_label_2.gridx = 2;
	    gbc_label_2.gridy = 0;
	    panel_pi_h_serve_tech_B2.add(label_2, gbc_label_2);
	    
	    label_pi_h_serve_tech_B2 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_serve_tech_B2 = new GridBagConstraints();
	    gbc_label_pi_h_serve_tech_B2.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_serve_tech_B2.gridx = 3;
	    gbc_label_pi_h_serve_tech_B2.gridy = 0;
	    panel_pi_h_serve_tech_B2.add(label_pi_h_serve_tech_B2, gbc_label_pi_h_serve_tech_B2);
	    }
	    
	    // field tech
	    {
	    JPanel panel_pi_h_field_tech_B2 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_field_tech_B2 = new GridBagConstraints();
	    gbc_panel_pi_h_field_tech_B2.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_field_tech_B2.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_field_tech_B2.gridx = 2;
	    gbc_panel_pi_h_field_tech_B2.gridy = 6;
	    pannelOpponent.add(panel_pi_h_field_tech_B2, gbc_panel_pi_h_field_tech_B2);
	    GridBagLayout gbl_panel_pi_h_field_tech_B2 = new GridBagLayout();
	    gbl_panel_pi_h_field_tech_B2.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_field_tech_B2.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_field_tech_B2.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_field_tech_B2.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_field_tech_B2.setLayout(gbl_panel_pi_h_field_tech_B2);
	    
	    JLabel label_FP = new JLabel("FP");
	    label_FP.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_FP = new GridBagConstraints();
	    gbc_label_FP.fill = GridBagConstraints.BOTH;
	    gbc_label_FP.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FP.gridx = 0;
	    gbc_label_FP.gridy = 0;
	    panel_pi_h_field_tech_B2.add(label_FP, gbc_label_FP);
	    
	    slider_pi_h_field_tech_B2 = new JSlider();
	    slider_pi_h_field_tech_B2.setName("pi_h_field_tech_B2_slider");
	    slider_pi_h_field_tech_B2.setSnapToTicks(true);
	    slider_pi_h_field_tech_B2.setPaintTicks(true);
	    slider_pi_h_field_tech_B2.setPaintLabels(true);
	    GridBagConstraints gbc_slider_field_tech = new GridBagConstraints();
	    gbc_slider_field_tech.fill = GridBagConstraints.BOTH;
	    gbc_slider_field_tech.insets = new Insets(0, 0, 0, 5);
	    gbc_slider_field_tech.gridx = 1;
	    gbc_slider_field_tech.gridy = 0;
	    panel_pi_h_field_tech_B2.add(slider_pi_h_field_tech_B2, gbc_slider_field_tech);
	    
	    JLabel label_FS = new JLabel("FS");
	    label_FS.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_FS = new GridBagConstraints();
	    gbc_label_FS.fill = GridBagConstraints.BOTH;
	    gbc_label_FS.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FS.gridx = 2;
	    gbc_label_FS.gridy = 0;
	    panel_pi_h_field_tech_B2.add(label_FS, gbc_label_FS);
	    
	    label_pi_h_field_tech_B2 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_field_tech_B2 = new GridBagConstraints();
	    gbc_label_pi_h_field_tech_B2.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_field_tech_B2.gridx = 3;
	    gbc_label_pi_h_field_tech_B2.gridy = 0;
	    panel_pi_h_field_tech_B2.add(label_pi_h_field_tech_B2, gbc_label_pi_h_field_tech_B2);
	    }
	    
	    // serve-field
	    {
	    JPanel panel_pi_h_serve_field_B2 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_serve_field_B2 = new GridBagConstraints();
	    gbc_panel_pi_h_serve_field_B2.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_serve_field_B2.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_serve_field_B2.gridx = 2;
	    gbc_panel_pi_h_serve_field_B2.gridy = 5;
	    pannelOpponent.add(panel_pi_h_serve_field_B2, gbc_panel_pi_h_serve_field_B2);
	    GridBagLayout gbl_panel_pi_h_serve_field_B2 = new GridBagLayout();
	    gbl_panel_pi_h_serve_field_B2.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_serve_field_B2.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_serve_field_B2.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_serve_field_B2.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_serve_field_B2.setLayout(gbl_panel_pi_h_serve_field_B2);
	    
	    JLabel label_1 = new JLabel("inside");
	    label_1.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_1 = new GridBagConstraints();
	    gbc_label_1.fill = GridBagConstraints.BOTH;
	    gbc_label_1.insets = new Insets(0, 0, 0, 5);
	    gbc_label_1.gridx = 0;
	    gbc_label_1.gridy = 0;
	    panel_pi_h_serve_field_B2.add(label_1, gbc_label_1);
	    
	    slider_pi_h_serve_field_B2 = new JSlider();
	    slider_pi_h_serve_field_B2.setName("pi_h_serve_field_B2_slider");
	    slider_pi_h_serve_field_B2.setSnapToTicks(true);
	    slider_pi_h_serve_field_B2.setPaintTicks(true);
	    slider_pi_h_serve_field_B2.setPaintLabels(true);
	    GridBagConstraints gbc_slider = new GridBagConstraints();
	    gbc_slider.fill = GridBagConstraints.BOTH;
	    gbc_slider.insets = new Insets(0, 0, 0, 5);
	    gbc_slider.gridx = 1;
	    gbc_slider.gridy = 0;
	    panel_pi_h_serve_field_B2.add(slider_pi_h_serve_field_B2, gbc_slider);
	    
	    label_2 = new JLabel("border");
	    label_2.setHorizontalAlignment(SwingConstants.LEFT);
	    gbc_label_2 = new GridBagConstraints();
	    gbc_label_2.fill = GridBagConstraints.BOTH;
	    gbc_label_2.insets = new Insets(0, 0, 0, 5);
	    gbc_label_2.gridx = 2;
	    gbc_label_2.gridy = 0;
	    panel_pi_h_serve_field_B2.add(label_2, gbc_label_2);
	    
	    label_pi_h_serve_field_B2 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_serve_field_B2 = new GridBagConstraints();
	    gbc_label_pi_h_serve_field_B2.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_serve_field_B2.gridx = 3;
	    gbc_label_pi_h_serve_field_B2.gridy = 0;
	    panel_pi_h_serve_field_B2.add(label_pi_h_serve_field_B2, gbc_label_pi_h_serve_field_B2);
	    }
	    
	    // field field
	    {
	    JPanel panel_pi_h_field_field_B2 = new JPanel();
	    GridBagConstraints gbc_panel_pi_h_field_field_B2 = new GridBagConstraints();
	    gbc_panel_pi_h_field_field_B2.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_h_field_field_B2.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_h_field_field_B2.gridx = 2;
	    gbc_panel_pi_h_field_field_B2.gridy = 7;
	    pannelOpponent.add(panel_pi_h_field_field_B2, gbc_panel_pi_h_field_field_B2);
	    GridBagLayout gbl_panel_pi_h_field_field_B2 = new GridBagLayout();
	    gbl_panel_pi_h_field_field_B2.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_h_field_field_B2.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_h_field_field_B2.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_h_field_field_B2.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_h_field_field_B2.setLayout(gbl_panel_pi_h_field_field_B2);
	    
	    JLabel label_FP = new JLabel("inside");
	    label_FP.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_FP = new GridBagConstraints();
	    gbc_label_FP.fill = GridBagConstraints.BOTH;
	    gbc_label_FP.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FP.gridx = 0;
	    gbc_label_FP.gridy = 0;
	    panel_pi_h_field_field_B2.add(label_FP, gbc_label_FP);
	    
	    slider_pi_h_field_field_B2 = new JSlider();
	    slider_pi_h_field_field_B2.setName("pi_h_field_field_B2_slider");
	    slider_pi_h_field_field_B2.setSnapToTicks(true);
	    slider_pi_h_field_field_B2.setPaintTicks(true);
	    slider_pi_h_field_field_B2.setPaintLabels(true);
	    GridBagConstraints gbc_slider_field_field = new GridBagConstraints();
	    gbc_slider_field_field.fill = GridBagConstraints.BOTH;
	    gbc_slider_field_field.insets = new Insets(0, 0, 0, 5);
	    gbc_slider_field_field.gridx = 1;
	    gbc_slider_field_field.gridy = 0;
	    panel_pi_h_field_field_B2.add(slider_pi_h_field_field_B2, gbc_slider_field_field);
	    
	    JLabel label_FS = new JLabel("border");
	    label_FS.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_FS = new GridBagConstraints();
	    gbc_label_FS.fill = GridBagConstraints.BOTH;
	    gbc_label_FS.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FS.gridx = 2;
	    gbc_label_FS.gridy = 0;
	    panel_pi_h_field_field_B2.add(label_FS, gbc_label_FS);
	    
	    label_pi_h_field_field_B2 = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_h_field_field_B2 = new GridBagConstraints();
	    gbc_label_pi_h_field_field_B2.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_h_field_field_B2.gridx = 3;
	    gbc_label_pi_h_field_field_B2.gridy = 0;
	    panel_pi_h_field_field_B2.add(label_pi_h_field_field_B2, gbc_label_pi_h_field_field_B2);
	    }
	    
	    
	    pannelOpponent.add(Box.createVerticalStrut(5));
	    pannelOpponent.add(new JSeparator(SwingConstants.HORIZONTAL));
	    pannelOpponent.add(Box.createVerticalStrut(5));
	    
	    // block
	    {
	    JPanel panel_pi_b = new JPanel();
	    GridBagConstraints gbc_panel_pi_b = new GridBagConstraints();
	    gbc_panel_pi_b.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_b.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_b.gridx = 2;
	    gbc_panel_pi_b.gridy = 8;
	    pannelOpponent.add(panel_pi_b, gbc_panel_pi_b);
	    GridBagLayout gbl_panel_pi_b = new GridBagLayout();
	    gbl_panel_pi_b.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_b.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_b.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_b.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_b.setLayout(gbl_panel_pi_b);
	    
	    JLabel label_FP = new JLabel("B1");
	    label_FP.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_FP = new GridBagConstraints();
	    gbc_label_FP.fill = GridBagConstraints.BOTH;
	    gbc_label_FP.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FP.gridx = 0;
	    gbc_label_FP.gridy = 1;
	    panel_pi_b.add(label_FP, gbc_label_FP);
	    
	    slider_pi_b_B = new JSlider();
	    slider_pi_b_B.setName("pi_b_slider_B");
	    slider_pi_b_B.setSnapToTicks(true);
	    slider_pi_b_B.setPaintTicks(true);
	    slider_pi_b_B.setPaintLabels(true);
	    GridBagConstraints gbc_slider_field_field = new GridBagConstraints();
	    gbc_slider_field_field.fill = GridBagConstraints.BOTH;
	    gbc_slider_field_field.insets = new Insets(0, 0, 0, 5);
	    gbc_slider_field_field.gridx = 1;
	    gbc_slider_field_field.gridy = 1;
	    panel_pi_b.add(slider_pi_b_B, gbc_slider_field_field);
	    
	    GridBagConstraints gbc_block = new GridBagConstraints();
	    gbc_block.fill = GridBagConstraints.BOTH;
	    gbc_block.insets = new Insets(0, 0, 0, 5);
	    gbc_block.gridx = 0;
	    gbc_block.gridy = 0;
	    panel_pi_b.add(new JLabel("Block:"), gbc_block);
	    
	    JLabel label_FS = new JLabel("B2");
	    label_FS.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_FS = new GridBagConstraints();
	    gbc_label_FS.fill = GridBagConstraints.BOTH;
	    gbc_label_FS.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FS.gridx = 2;
	    gbc_label_FS.gridy = 1;
	    panel_pi_b.add(label_FS, gbc_label_FS);
	    
	    label_pi_b_B = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_b = new GridBagConstraints();
	    gbc_label_pi_b.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_b.gridx = 3;
	    gbc_label_pi_b.gridy = 1;
	    panel_pi_b.add(label_pi_b_B, gbc_label_pi_b);
	    }
	    
	    // block
	    {
	    JPanel panel_pi_s = new JPanel();
	    GridBagConstraints gbc_panel_pi_s = new GridBagConstraints();
	    gbc_panel_pi_s.insets = new Insets(0, 0, 5, 5);
	    gbc_panel_pi_s.fill = GridBagConstraints.BOTH;
	    gbc_panel_pi_s.gridx = 1;
	    gbc_panel_pi_s.gridy = 8;
	    pannelOpponent.add(panel_pi_s, gbc_panel_pi_s);
	    GridBagLayout gbl_panel_pi_s = new GridBagLayout();
	    gbl_panel_pi_s.columnWidths = new int[]{45, 45, 45, 30, 0};
	    gbl_panel_pi_s.rowHeights = new int[]{38, 0};
	    gbl_panel_pi_s.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
	    gbl_panel_pi_s.rowWeights = new double[]{0.0, Double.MIN_VALUE};
	    panel_pi_s.setLayout(gbl_panel_pi_s);
	    
	    JLabel label_FP = new JLabel("A1");
	    label_FP.setHorizontalAlignment(SwingConstants.RIGHT);
	    GridBagConstraints gbc_label_FP = new GridBagConstraints();
	    gbc_label_FP.fill = GridBagConstraints.BOTH;
	    gbc_label_FP.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FP.gridx = 0;
	    gbc_label_FP.gridy = 1;
	    panel_pi_s.add(label_FP, gbc_label_FP);
	    
	    slider_pi_s_B = new JSlider();
	    slider_pi_s_B.setName("pi_s_slider_B");
	    slider_pi_s_B.setSnapToTicks(true);
	    slider_pi_s_B.setPaintTicks(true);
	    slider_pi_s_B.setPaintLabels(true);
	    GridBagConstraints gbc_slider_field_field = new GridBagConstraints();
	    gbc_slider_field_field.fill = GridBagConstraints.BOTH;
	    gbc_slider_field_field.insets = new Insets(0, 0, 0, 5);
	    gbc_slider_field_field.gridx = 1;
	    gbc_slider_field_field.gridy = 1;
	    panel_pi_s.add(slider_pi_s_B, gbc_slider_field_field);
	    
	    GridBagConstraints gbc_slock = new GridBagConstraints();
	    gbc_slock.fill = GridBagConstraints.BOTH;
	    gbc_slock.insets = new Insets(0, 0, 0, 5);
	    gbc_slock.gridx = 0;
	    gbc_slock.gridy = 0;
	    panel_pi_s.add(new JLabel("Serve:"), gbc_slock);
	    
	    JLabel label_FS = new JLabel("A2");
	    label_FS.setHorizontalAlignment(SwingConstants.LEFT);
	    GridBagConstraints gbc_label_FS = new GridBagConstraints();
	    gbc_label_FS.fill = GridBagConstraints.BOTH;
	    gbc_label_FS.insets = new Insets(0, 0, 0, 5);
	    gbc_label_FS.gridx = 2;
	    gbc_label_FS.gridy = 1;
	    panel_pi_s.add(label_FS, gbc_label_FS);
	    
	    label_pi_s_B = new JLabel("0.5");
	    GridBagConstraints gbc_label_pi_s = new GridBagConstraints();
	    gbc_label_pi_s.fill = GridBagConstraints.BOTH;
	    gbc_label_pi_s.gridx = 3;
	    gbc_label_pi_s.gridy = 1;
	    panel_pi_s.add(label_pi_s_B, gbc_label_pi_s);
	    }
	    
	    
	    JButton btnReset_B = new JButton("Reset");
	    btnReset_B.setToolTipText("Reset to basic strat");
	    GridBagConstraints gbc_btnReset_B = new GridBagConstraints();
	    gbc_btnReset_B.insets = new Insets(0, 0, 5, 0);
	    gbc_btnReset_B.gridx = 3;
	    gbc_btnReset_B.gridy = 8;
	    pannelOpponent.add(btnReset_B, gbc_btnReset_B);
	    
	    btnReset_B.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				label_pi_h_serve_tech_B1.setText("0.5");
				label_pi_h_serve_field_B1.setText("0.5");
				label_pi_h_field_tech_B1.setText("0.5");
				label_pi_h_field_field_B1.setText("0.5");
				label_pi_h_serve_tech_B2.setText("0.5");
				label_pi_h_serve_field_B2.setText("0.5");
				label_pi_h_field_tech_B2.setText("0.5");
				label_pi_h_field_field_B2.setText("0.5");
				label_pi_b_B.setText("0.5");
				label_pi_s_B.setText("0.5");
				
				slider_pi_h_serve_tech_B1.setValue(50);
				slider_pi_h_serve_field_B1.setValue(50);
				slider_pi_h_field_tech_B1.setValue(50);
				slider_pi_h_field_field_B1.setValue(50);
				slider_pi_h_serve_tech_B2.setValue(50);
				slider_pi_h_serve_field_B2.setValue(50);
				slider_pi_h_field_tech_B2.setValue(50);
				slider_pi_h_field_field_B2.setValue(50);
				
				slider_pi_b_B.setValue(50);
				slider_pi_s_B.setValue(50);
			}
	    });
	    
	    JButton btnRiskyB = new JButton("Risky");
	    btnReset.setToolTipText("Set to risky Strat");
	    GridBagConstraints gbc_btnRiskyB = new GridBagConstraints();
	    gbc_btnRiskyB.insets = new Insets(0, 0, 5, 0);
	    gbc_btnRiskyB.gridx = 3;
	    gbc_btnRiskyB.gridy = 7;
	    pannelOpponent.add(btnRiskyB, gbc_btnRiskyB);
	    
	    JButton btnSafeB = new JButton("Safe");
	    btnReset.setToolTipText("Set to risky Strat");
	    GridBagConstraints gbc_btnSafeB = new GridBagConstraints();
	    gbc_btnSafeB.insets = new Insets(0, 0, 5, 0);
	    gbc_btnSafeB.gridx = 3;
	    gbc_btnSafeB.gridy = 6;
	    pannelOpponent.add(btnSafeB, gbc_btnSafeB);
	    
	    btnRiskyB.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				label_pi_h_serve_tech_B1.setText("1.0");
				label_pi_h_serve_field_B1.setText("1.0");
				label_pi_h_field_tech_B1.setText("1.0");
				label_pi_h_field_field_B1.setText("1.0");
				label_pi_h_serve_tech_B2.setText("1.0");
				label_pi_h_serve_field_B2.setText("1.0");
				label_pi_h_field_tech_B2.setText("1.0");
				label_pi_h_field_field_B2.setText("1.0");
				label_pi_b_B.setText("1.0");
				label_pi_s_B.setText("1.0");
				
				slider_pi_h_serve_tech_B1.setValue(100);
				slider_pi_h_serve_field_B1.setValue(100);
				slider_pi_h_field_tech_B1.setValue(100);
				slider_pi_h_field_field_B1.setValue(100);
				slider_pi_h_serve_tech_B2.setValue(100);
				slider_pi_h_serve_field_B2.setValue(100);
				slider_pi_h_field_tech_B2.setValue(100);
				slider_pi_h_field_field_B2.setValue(100);
				
				slider_pi_b_B.setValue(100);
				slider_pi_s_B.setValue(100);
			}
	    });
	    
	    btnSafeB.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				label_pi_h_serve_tech_B1.setText("0.0");
				label_pi_h_serve_field_B1.setText("0.0");
				label_pi_h_field_tech_B1.setText("0.0");
				label_pi_h_field_field_B1.setText("0.0");
				label_pi_h_serve_tech_B2.setText("0.0");
				label_pi_h_serve_field_B2.setText("0.0");
				label_pi_h_field_tech_B2.setText("0.0");
				label_pi_h_field_field_B2.setText("0.0");
				label_pi_b_B.setText("0.0");
				label_pi_s_B.setText("0.0");
				
				slider_pi_h_serve_tech_B1.setValue(0);
				slider_pi_h_serve_field_B1.setValue(0);
				slider_pi_h_field_tech_B1.setValue(0);
				slider_pi_h_field_field_B1.setValue(0);
				slider_pi_h_serve_tech_B2.setValue(0);
				slider_pi_h_serve_field_B2.setValue(0);
				slider_pi_h_field_tech_B2.setValue(0);
				slider_pi_h_field_field_B2.setValue(0);
				
				slider_pi_b_B.setValue(0);
				slider_pi_s_B.setValue(0);
			}
	    });
	    
	    /**
	     * change listener
	     */
	    ChangeListener changelistenerB = new ChangeListener() {
	    	public void stateChanged(ChangeEvent e) {
	    		JSlider source = (JSlider)e.getSource();
	    		double d = 0.0;
	    		d = source.getValue()*1.0/100;
	    		if (source.getName()=="pi_h_serve_tech_B1_slider")
	    			label_pi_h_serve_tech_B1.setText(d + "");
	    		if (source.getName()=="pi_h_field_tech_B1_slider")
	    			label_pi_h_field_tech_B1.setText(d + "");
	    		if (source.getName()=="pi_h_serve_field_B1_slider")
	    			label_pi_h_serve_field_B1.setText(d + "");
	    		if (source.getName()=="pi_h_field_field_B1_slider")
	    			label_pi_h_field_field_B1.setText(d + "");
	    		if (source.getName()=="pi_h_serve_tech_B2_slider")
	    			label_pi_h_serve_tech_B2.setText(d + "");
	    		if (source.getName()=="pi_h_field_tech_B2_slider")
    			label_pi_h_field_tech_B2.setText(d + "");
	    		if (source.getName()=="pi_h_serve_field_B2_slider")
	    			label_pi_h_serve_field_B2.setText(d + "");
	    		if (source.getName()=="pi_h_field_field_B2_slider")
    			label_pi_h_field_field_B2.setText(d + "");
	    		if (source.getName()=="pi_b_slider_B")
	    			label_pi_b_B.setText(d + "");
	    		if (source.getName()=="pi_s_slider_B")
    			label_pi_s_B.setText(d + "");
	    	}
	    };
	    
	    slider_pi_h_serve_tech_B1.addChangeListener(changelistenerB);
	    slider_pi_h_field_tech_B1.addChangeListener(changelistenerB);
	    slider_pi_h_serve_tech_B2.addChangeListener(changelistenerB);
	    slider_pi_h_field_tech_B2.addChangeListener(changelistenerB);
	    slider_pi_h_serve_field_B1.addChangeListener(changelistenerB);
	    slider_pi_h_field_field_B1.addChangeListener(changelistenerB);
	    slider_pi_h_serve_field_B2.addChangeListener(changelistenerB);
	    slider_pi_h_field_field_B2.addChangeListener(changelistenerB);
	    slider_pi_b_B.addChangeListener(changelistenerB);
	    slider_pi_s_B.addChangeListener(changelistenerB);
	    
	        
	    ////////////////////////////////////////////
	    JPanel pannelSettings = new JPanel();
	    ///////////////////////////////////////////
	    this.addTab("Settings", pannelSettings);
	    
	    GridBagLayout gbl_pannelSettings = new GridBagLayout();
	    gbl_pannelSettings.columnWidths = new int[] {0, 80, 25, 200, 25};
	    gbl_pannelSettings.rowHeights = new int[] {0, 35, 35, 35, 0};
	    gbl_pannelSettings.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0};
	    gbl_pannelSettings.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0};
	    pannelSettings.setLayout(gbl_pannelSettings);
	    
	    JLabel lblSets = new JLabel("Number of Sets");
	    GridBagConstraints gbc_lblPoints = new GridBagConstraints();
	    gbc_lblPoints.insets = new Insets(0, 0, 5, 5);
	    gbc_lblPoints.gridx = 1;
	    gbc_lblPoints.gridy = 1;
	    pannelSettings.add(lblSets, gbc_lblPoints);
	    
	    spinner_MaxNumberOfSets = new JSpinner();
	    spinner_MaxNumberOfSets.setModel(new SpinnerNumberModel(100, 100, 1000000, 10));
	    GridBagConstraints gbc_spinner_WaitTime = new GridBagConstraints();
	    gbc_spinner_WaitTime.insets = new Insets(0, 0, 5, 5);
	    gbc_spinner_WaitTime.gridx = 3;
	    gbc_spinner_WaitTime.gridy = 1;
	    pannelSettings.add(spinner_MaxNumberOfSets, gbc_spinner_WaitTime);
	    
	    JLabel lblSpeed = new JLabel("Speed");
	    GridBagConstraints gbc_lblSpeed = new GridBagConstraints();
	    gbc_lblSpeed.insets = new Insets(0, 0, 5, 5);
	    gbc_lblSpeed.gridx = 1;
	    gbc_lblSpeed.gridy = 2;
	    pannelSettings.add(lblSpeed, gbc_lblSpeed);
	    
	    JLabel lblSlow = new JLabel("slow");
	    GridBagConstraints gbc_lblSlow = new GridBagConstraints();
	    gbc_lblSlow.insets = new Insets(0, 0, 5, 5);
	    gbc_lblSlow.gridx = 2;
	    gbc_lblSlow.gridy = 2;
	    pannelSettings.add(lblSlow, gbc_lblSlow);
	    
	    slider_speed = new JSlider();
	    slider_speed.setMaximum(2000);
	    slider_speed.setMinimum(1);
	    slider_speed.setValue(1000);
	    GridBagConstraints gbc_slider_speed = new GridBagConstraints();
	    gbc_slider_speed.insets = new Insets(0, 0, 5, 5);
	    gbc_slider_speed.gridx = 3;
	    gbc_slider_speed.gridy = 2;
	    pannelSettings.add(slider_speed, gbc_slider_speed);
	    
	    JLabel lblFast = new JLabel("fast");
	    GridBagConstraints gbc_lblFast = new GridBagConstraints();
	    gbc_lblFast.insets = new Insets(0, 0, 5, 0);
	    gbc_lblFast.gridx = 4;
	    gbc_lblFast.gridy = 2;
	    pannelSettings.add(lblFast, gbc_lblFast);
	    
	    JLabel lblGui = new JLabel("Gui");
	    GridBagConstraints gbc_lblGui = new GridBagConstraints();
	    gbc_lblGui.insets = new Insets(0, 0, 5, 5);
	    gbc_lblGui.gridx = 1;
	    gbc_lblGui.gridy = 3;
	    pannelSettings.add(lblGui, gbc_lblGui);
	    
	    chckbx_Gui = new JCheckBox("Watch Game",true);
	    GridBagConstraints gbc_chckbxGui = new GridBagConstraints();
	    gbc_chckbxGui.insets = new Insets(0, 0, 5, 5);
	    gbc_chckbxGui.gridx = 3;
	    gbc_chckbxGui.gridy = 3;
	    pannelSettings.add(chckbx_Gui, gbc_chckbxGui);		
	}
	
	
	public JSpinner getSpinner_MaxPoints(){
		return spinner_MaxNumberOfSets;
	}
	
	public JTextField getTxt_teamB() {
		return txt_teamB;
	}


	public void setTxt_teamB(JTextField txt_teamB) {
		this.txt_teamB = txt_teamB;
	}

	
	public JTextField getTxt_nameB1() {
		return txt_nameB1;
	}


	public JTextField getTxt_skillsTeamB() {
		return txt_skillsTeamB;
	}


	public JTextField getTxt_nameB2() {
		return txt_nameB2;
	}


	public JTextField getTxt_teamA() {
		return txt_teamA;
	}


	public void setTxt_teamA(JTextField txt_teamA) {
		this.txt_teamA = txt_teamA;
	}


	public JTextField getTxt_nameA1() {
		return txt_nameA1;
	}


	public void setTxt_nameA1(JTextField txt_nameA1) {
		this.txt_nameA1 = txt_nameA1;
	}


	public JTextField getTxt_skillsTeamA() {
		return txt_skillsTeamA;
	}


	public void setTxt_skillsA1(JTextField txt_skillsA1) {
		this.txt_skillsTeamA = txt_skillsA1;
	}


	public JTextField getTxt_nameA2() {
		return txt_nameA2;
	}


	public void setTxt_nameA2(JTextField txt_nameA2) {
		this.txt_nameA2 = txt_nameA2;
	}


	public ButtonGroup getButtonGroup() {
		return buttonGroup;
	}


	public void setButtonGroup(ButtonGroup buttonGroup) {
		this.buttonGroup = buttonGroup;
	}


	public JCheckBox getChckbx_Gui() {
		return chckbx_Gui;
	}


	public void setChckbx_Gui(JCheckBox chckbx_Gui) {
		this.chckbx_Gui = chckbx_Gui;
	}

	public JSlider getSLider_speed(){
		return slider_speed;
	}

	public String getChoosenStratTeamA() {
		return choosenStratTeamA;
	}


	public void setChoosenStratTeamA(String choosenStratTeamA) {
		this.choosenStratTeamA = choosenStratTeamA;
	}

}
