package de.ubt.wm.sb.gui;


public class GUIManager {

	private static GUIManager guiManager = new GUIManager();
	
	private MainFrame mainFrame;
	private ViewSimFrame viewSimFrame;
	
	private GUIManager(){
		this.mainFrame = new MainFrame();
	}
	
	public static GUIManager getInstance(){
		return guiManager;
	}
	
	public MainFrame getMainFrame(){
		return this.mainFrame;
	}

	public ViewSimFrame getViewSimFrame() {
		return viewSimFrame;
	}

	public void setViewSimFrame(ViewSimFrame viewSimFrame) {
		this.viewSimFrame = viewSimFrame;
	}

}
