package de.ubt.wm.sb.gui;

import javax.swing.SwingUtilities;
import javax.swing.UIManager;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import de.ubt.wm.sb.sim.MainSim;

public class MainGui {

	static final Logger log4j = LogManager.getLogger(MainSim.class.getName());
	
	public static boolean isRunning = false;
		
	public static void main(String[] args) throws Exception {
		
		isRunning = true;
		
		try {
//			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
//			UIManager.getCrossPlatformLookAndFeelClassName();
			UIManager.setLookAndFeel(
					UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {

		}

		/**
		 * initial thread schedules the GUI Runnable object that initializes the
		 * GUI and schedule that object for execution on the event dispatch
		 * thread
		 **/
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				GUIManager.getInstance().getMainFrame();
			}
		});
	}

}
