package de.ubt.wm.sb.model.strategy;

import de.ubt.wm.sb.model.State;
import de.ubt.wm.sb.model.TeamAction;

public interface RealStrat {
	
	public TeamAction getTeamAction(State s, double r);
	
	public TeamAction servingRule(State s, double r);
	public TeamAction receptionRule(State s, double r);
	public TeamAction defendingRule(State s, double r);
	public TeamAction settingRule(State s, double r);
	public TeamAction attackingRule(State s, double r);
	
	public TeamAction otherTeamServingRule(State s, double r);
	public TeamAction otherTeamReceptionRule(State s, double r);
	public TeamAction otherTeamDefendingRule(State s, double r);
	public TeamAction otherTeamSettingRule(State s, double r);
	public TeamAction otherTeamAttackingRule(State s, double r);
	
	public String toStringShort();
}
