package de.ubt.wm.sb.probs;

import de.ubt.wm.sb.model.BallProperty;
import de.ubt.wm.sb.model.HitTechnique;

public class Prob_DefRec extends Prob_Hit{

	private BallProperty strength;

	public Prob_DefRec(HitTechnique tech, int observations, Prob_Hit pred, double succProb, double faultProb,
			BallProperty strength) {
		super(tech, observations, pred, succProb, faultProb);
		this.strength = strength;
	}

	public BallProperty getStrength() {
		return strength;
	}

	public void setStrength(BallProperty strength) {
		this.strength = strength;
	}
	
	public String toString(){
		return super.getTech() + "^" + strength.toString() + "=[" + super.getNumberOfObservations() + ", " + super.getSuccProb() + ", " + super.getFaultProb() + ", " + super.getNeighbourProb() + "]";
	}
	
	public String printName(){
		return super.getTech() + "^" + strength.toString();
	}
}
