package de.ubt.wm.sb.junit;

import static org.junit.Assert.*;

import java.util.Arrays;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.ubt.wm.sb.model.Field;

public class NeighbourField {

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void test() {
		Field[] outsideNeighbours = Field.getNeighbourOutsideFieldsOf(Field.A22);
		
		assertTrue("A22 has 0 outside neighbours", outsideNeighbours.length == 0);
		
		outsideNeighbours = Field.getNeighbourOutsideFieldsOf(Field.B11);
		
		assertTrue("B11 has 5 outside neighbours", outsideNeighbours.length == 5);
		
		outsideNeighbours = Field.getNeighbourOutsideFieldsOf(Field.A34);
		System.out.println(Arrays.asList(outsideNeighbours).toString());
		assertTrue("A34 has 3 outside neighbours", outsideNeighbours.length == 3);
	}

}
