package de.ubt.wm.sb.exceptions;

import de.ubt.wm.sb.model.Player;
import de.ubt.wm.sb.model.PlayerAction;

public class StateResetException extends Exception {
    /**
	 * 
	 */
	private static final long serialVersionUID = -1969253008808525337L;
	
	private Player hittingPlayer;
	private PlayerAction playerAction;

	public StateResetException(String message, Player player, PlayerAction playerAction) {
        super(message);
        this.hittingPlayer = player;
        this.playerAction = playerAction;
    
	}

	public Player getHittingPlayer() {
		return hittingPlayer;
	}

	public void setHittingPlayer(Player hittingPlayer) {
		this.hittingPlayer = hittingPlayer;
	}

	public PlayerAction getPlayerAction() {
		return playerAction;
	}

	public void setPlayerAction(PlayerAction playerAction) {
		this.playerAction = playerAction;
	}
	
	
	
}
