package de.ubt.wm.sb.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import de.ubt.wm.sb.model.Game;
import de.ubt.wm.sb.sim.SimulationManager;

public class ResultFrame extends JFrame {

	private static final long serialVersionUID = 1L;
	private JLabel lblMean;
	private JLabel lblSd;
	private JLabel lblAttacks;
	private JLabel lblValuemeanattacks;
	private JLabel lblValuesdattacks;
	private JLabel lbldirectPoints;
	private JLabel lblValuemeanpoints;
	private JLabel lblSdpoints;
	private JLabel lbldirectFaults;
	private JLabel lblValuemeanfaults;
	private JLabel lblSdfaults;
	private JLabel lblPointsattacks;
	private JLabel lblFaultsattacks;
	private JLabel lblR;
	private JLabel lblRpoints;	
	private JLabel lblRfaults;	
	private JLabel lblCovariance;	
	private JLabel lblCovarpoints;	
	private JLabel lblCovarfaults;	
	private JLabel lblCorrpoints;	
	private JLabel lblCorrfaults;	
	private JLabel lblSdr;	
	private JLabel lblSdrpoints;
	private JLabel lblSdrfaults;
	private Component verticalStrut;
	private Component verticalStrut_1;
	private JTabbedPane tabbedPane;
	private JPanel panel_teamB_fA;
	private JLabel lblMeanB;
	private JLabel lblSdB;
	private JLabel lblAttacksB;
	private JLabel lbldirectPointsB;
	private JLabel lbldirectFaultsB;
	private JLabel lblValuemeanattacksB;
	private JLabel lblValuesdattacksB;
	private JLabel lblValuemeanpointsB;
	private JLabel lblValuesdpointsB;
	private JLabel lblValuemeanfaultsB;
	private JLabel lblValuesdfaultsB;
	private JLabel lblRB;
	private JLabel lblCovarianceB;
	private JLabel lblCorrelationB;
	private JLabel lblSdrB;
	private JLabel lblPointsattacksB;
	private JLabel lblFaultsattacksB;
	private JLabel lblRpointsB;
	private JLabel lblRfaultsb;
	private JLabel lblCovarpointsb;
	private JLabel lblCovarfaultsb;
	private JLabel lblCorrpointsb;
	private JLabel lblCorrfaultsb;
	private JLabel lblSdrpointsb;
	private JLabel lblSdrfaultsb;
	private JPanel Validation;
	private JLabel lblValidation;
	private JLabel lblGewonneneStzeTeam_1;
	private JLabel lblSatzGewinnwahrscheinlichkeit;
	private JLabel lblWonsets_1;
	private JLabel lblWonsetsprob_1;
	private Component verticalStrut_2;
	private Component verticalStrut_3;
	private Component verticalStrut_4;
	private Component verticalStrut_5;
	private Component verticalStrut_6;
	private Component verticalStrut_7;
	private JLabel lblFieldAttackStatistic;
	private JLabel lblStrategy_teamA;
	private JLabel lblStrategy_teamB;
	private JLabel label;
	private JPanel panel_teamA_serves;
	private Component verticalStrut_8;
	private JLabel lbl_Strat_teamA_serve;
	private Component verticalStrut_9;
	private JLabel lbl_1;
	private JLabel label_4;
	private JLabel label_5;
	private JLabel lblserves;
	private JLabel mean_servesA;
	private JLabel sd_servesA;
	private JLabel label_9;
	private JLabel mean_points_servesA;
	private JLabel sd_points_servesA;
	private JLabel label_12;
	private JLabel mean_faults_servesA;
	private JLabel sd_faults_servesA;
	private Component verticalStrut_10;
	private JLabel lblPointsserves;
	private JLabel lblFaultsserves;
	private JLabel label_17;
	private JLabel R_points_servesA;
	private JLabel R_faults_servesA;
	private JLabel label_20;
	private JLabel CoVar_points_servesA;
	private JLabel CoVar_faults_servesA;
	private JLabel label_23;
	private JLabel Corr_points_servesA;
	private JLabel Corr_faults_servesA;
	private JLabel label_26;
	private JLabel SDR_points_servesA;
	private JLabel SDR_faults_servesA;
	private Component verticalStrut_11;
	private JPanel panel_teamB_serves;
	private Component verticalStrut_12;
	private JLabel lbl_Strat_TeamBServes;
	private Component verticalStrut_13;
	private JLabel lblServeStatistic;
	private JLabel label_32;
	private JLabel label_33;
	private JLabel lblserves_1;
	private JLabel lbl_value_meanServesB;
	private JLabel lbl_value_sdServesB;
	private JLabel label_37;
	private JLabel lbl_value_meanPoints_ServesB;
	private JLabel lbl_value_sdPoints_servesB;
	private JLabel label_40;
	private JLabel lbl_value_meanFault_ServesB;
	private JLabel lbl_value_sdFault_servesB;
	private Component verticalStrut_14;
	private JLabel lblPointsserves_1;
	private JLabel lblFaultsserves_1;
	private JLabel label_45;
	private JLabel R_Points_ServesB;
	private JLabel R_Faults_ServesB;
	private JLabel label_48;
	private JLabel CoVar_Points_ServesB;
	private JLabel CoVar_Faults_ServesB;
	private JLabel label_51;
	private JLabel Corr_Points_ServesB;
	private JLabel Corr_Faults_ServesB;
	private JLabel label_54;
	private JLabel SDR_Points_ServesB;
	private JLabel SDR_Faults_ServesB;
	private Component verticalStrut_15;
	
	
	
	public ResultFrame(SimulationManager sim) {
		
		final MainFrame mainFrame = GUIManager.getInstance().getMainFrame();
		final EditPane editPane = mainFrame.getEditPane();
		
		this.setTitle("Results n=" + sim.teamA_serveStatistics.size());
		
		tabbedPane = new JTabbedPane(JTabbedPane.TOP);
		tabbedPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
		getContentPane().add(tabbedPane, BorderLayout.NORTH);
		
		panel_teamA_serves = new JPanel();
		panel_teamA_serves.setBackground(Color.WHITE);
		tabbedPane.addTab(editPane.txt_teamA.getText() + " Serves", null, panel_teamA_serves, null);
		GridBagLayout gbl_panel_teamA_serves = new GridBagLayout();
		gbl_panel_teamA_serves.columnWidths = new int[]{35, 320, 0, 5, 0, 60, 0};
		gbl_panel_teamA_serves.rowHeights = new int[]{0, 0, 0, 18, 18, 18, 18, 0, 0, 0, 0, 0, 0, 0, 0};
		gbl_panel_teamA_serves.columnWeights = new double[]{0.0, 1.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		gbl_panel_teamA_serves.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, Double.MIN_VALUE};
		panel_teamA_serves.setLayout(gbl_panel_teamA_serves);
		
		verticalStrut_8 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_8 = new GridBagConstraints();
		gbc_verticalStrut_8.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut_8.gridx = 1;
		gbc_verticalStrut_8.gridy = 0;
		panel_teamA_serves.add(verticalStrut_8, gbc_verticalStrut_8);
		
		lbl_Strat_teamA_serve = new JLabel("Strategy: <dynamic>");
		GridBagConstraints gbc_lbl_Strat_teamA_serve = new GridBagConstraints();
		gbc_lbl_Strat_teamA_serve.insets = new Insets(0, 0, 5, 5);
		gbc_lbl_Strat_teamA_serve.gridx = 1;
		gbc_lbl_Strat_teamA_serve.gridy = 1;
		panel_teamA_serves.add(lbl_Strat_teamA_serve, gbc_lbl_Strat_teamA_serve);
		
		verticalStrut_9 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_9 = new GridBagConstraints();
		gbc_verticalStrut_9.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut_9.gridx = 1;
		gbc_verticalStrut_9.gridy = 2;
		panel_teamA_serves.add(verticalStrut_9, gbc_verticalStrut_9);
		
		lbl_1 = new JLabel("Serve Statistic");
		lbl_1.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lbl_1 = new GridBagConstraints();
		gbc_lbl_1.insets = new Insets(0, 0, 5, 5);
		gbc_lbl_1.gridx = 1;
		gbc_lbl_1.gridy = 3;
		panel_teamA_serves.add(lbl_1, gbc_lbl_1);
		
		label_4 = new JLabel("mean");
		label_4.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_label_4 = new GridBagConstraints();
		gbc_label_4.insets = new Insets(0, 0, 5, 5);
		gbc_label_4.gridx = 2;
		gbc_label_4.gridy = 3;
		panel_teamA_serves.add(label_4, gbc_label_4);
		
		label_5 = new JLabel("sd");
		label_5.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_label_5 = new GridBagConstraints();
		gbc_label_5.insets = new Insets(0, 0, 5, 5);
		gbc_label_5.gridx = 4;
		gbc_label_5.gridy = 3;
		panel_teamA_serves.add(label_5, gbc_label_5);
		
		lblserves = new JLabel("#serves");
		GridBagConstraints gbc_lblserves = new GridBagConstraints();
		gbc_lblserves.insets = new Insets(0, 0, 5, 5);
		gbc_lblserves.gridx = 1;
		gbc_lblserves.gridy = 4;
		panel_teamA_serves.add(lblserves, gbc_lblserves);
		
		mean_servesA = new JLabel("0.0");
		GridBagConstraints gbc_mean_servesA = new GridBagConstraints();
		gbc_mean_servesA.insets = new Insets(0, 0, 5, 5);
		gbc_mean_servesA.gridx = 2;
		gbc_mean_servesA.gridy = 4;
		panel_teamA_serves.add(mean_servesA, gbc_mean_servesA);
		
		sd_servesA = new JLabel("0.0");
		GridBagConstraints gbc_sd_servesA = new GridBagConstraints();
		gbc_sd_servesA.insets = new Insets(0, 0, 5, 5);
		gbc_sd_servesA.gridx = 4;
		gbc_sd_servesA.gridy = 4;
		panel_teamA_serves.add(sd_servesA, gbc_sd_servesA);
		
		label_9 = new JLabel("#direct points");
		GridBagConstraints gbc_label_9 = new GridBagConstraints();
		gbc_label_9.insets = new Insets(0, 0, 5, 5);
		gbc_label_9.gridx = 1;
		gbc_label_9.gridy = 5;
		panel_teamA_serves.add(label_9, gbc_label_9);
		
		mean_points_servesA = new JLabel("0.0");
		GridBagConstraints gbc_mean_points_servesA = new GridBagConstraints();
		gbc_mean_points_servesA.insets = new Insets(0, 0, 5, 5);
		gbc_mean_points_servesA.gridx = 2;
		gbc_mean_points_servesA.gridy = 5;
		panel_teamA_serves.add(mean_points_servesA, gbc_mean_points_servesA);
		
		sd_points_servesA = new JLabel("0.0");
		GridBagConstraints gbc_sd_points_servesA = new GridBagConstraints();
		gbc_sd_points_servesA.insets = new Insets(0, 0, 5, 5);
		gbc_sd_points_servesA.gridx = 4;
		gbc_sd_points_servesA.gridy = 5;
		panel_teamA_serves.add(sd_points_servesA, gbc_sd_points_servesA);
		
		label_12 = new JLabel("#direct faults");
		GridBagConstraints gbc_label_12 = new GridBagConstraints();
		gbc_label_12.insets = new Insets(0, 0, 5, 5);
		gbc_label_12.gridx = 1;
		gbc_label_12.gridy = 6;
		panel_teamA_serves.add(label_12, gbc_label_12);
		
		mean_faults_servesA = new JLabel("0.0");
		GridBagConstraints gbc_mean_faults_servesA = new GridBagConstraints();
		gbc_mean_faults_servesA.insets = new Insets(0, 0, 5, 5);
		gbc_mean_faults_servesA.gridx = 2;
		gbc_mean_faults_servesA.gridy = 6;
		panel_teamA_serves.add(mean_faults_servesA, gbc_mean_faults_servesA);
		
		sd_faults_servesA = new JLabel("0.0");
		GridBagConstraints gbc_sd_faults_servesA = new GridBagConstraints();
		gbc_sd_faults_servesA.insets = new Insets(0, 0, 5, 5);
		gbc_sd_faults_servesA.gridx = 4;
		gbc_sd_faults_servesA.gridy = 6;
		panel_teamA_serves.add(sd_faults_servesA, gbc_sd_faults_servesA);
		
		verticalStrut_10 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_10 = new GridBagConstraints();
		gbc_verticalStrut_10.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut_10.gridx = 1;
		gbc_verticalStrut_10.gridy = 7;
		panel_teamA_serves.add(verticalStrut_10, gbc_verticalStrut_10);
		
		lblPointsserves = new JLabel("points/serves");
		lblPointsserves.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lblPointsserves = new GridBagConstraints();
		gbc_lblPointsserves.insets = new Insets(0, 0, 5, 5);
		gbc_lblPointsserves.gridx = 2;
		gbc_lblPointsserves.gridy = 8;
		panel_teamA_serves.add(lblPointsserves, gbc_lblPointsserves);
		
		lblFaultsserves = new JLabel("faults/serves");
		lblFaultsserves.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lblFaultsserves = new GridBagConstraints();
		gbc_lblFaultsserves.insets = new Insets(0, 0, 5, 5);
		gbc_lblFaultsserves.gridx = 4;
		gbc_lblFaultsserves.gridy = 8;
		panel_teamA_serves.add(lblFaultsserves, gbc_lblFaultsserves);
		
		label_17 = new JLabel("R");
		GridBagConstraints gbc_label_17 = new GridBagConstraints();
		gbc_label_17.insets = new Insets(0, 0, 5, 5);
		gbc_label_17.gridx = 1;
		gbc_label_17.gridy = 9;
		panel_teamA_serves.add(label_17, gbc_label_17);
		
		R_points_servesA = new JLabel("0.0");
		GridBagConstraints gbc_R_points_servesA = new GridBagConstraints();
		gbc_R_points_servesA.insets = new Insets(0, 0, 5, 5);
		gbc_R_points_servesA.gridx = 2;
		gbc_R_points_servesA.gridy = 9;
		panel_teamA_serves.add(R_points_servesA, gbc_R_points_servesA);
		
		R_faults_servesA = new JLabel("0.0");
		GridBagConstraints gbc_R_faults_servesA = new GridBagConstraints();
		gbc_R_faults_servesA.insets = new Insets(0, 0, 5, 5);
		gbc_R_faults_servesA.gridx = 4;
		gbc_R_faults_servesA.gridy = 9;
		panel_teamA_serves.add(R_faults_servesA, gbc_R_faults_servesA);
		
		label_20 = new JLabel("covariance");
		GridBagConstraints gbc_label_20 = new GridBagConstraints();
		gbc_label_20.insets = new Insets(0, 0, 5, 5);
		gbc_label_20.gridx = 1;
		gbc_label_20.gridy = 10;
		panel_teamA_serves.add(label_20, gbc_label_20);
		
		CoVar_points_servesA = new JLabel("0.0");
		GridBagConstraints gbc_CoVar_points_servesA = new GridBagConstraints();
		gbc_CoVar_points_servesA.insets = new Insets(0, 0, 5, 5);
		gbc_CoVar_points_servesA.gridx = 2;
		gbc_CoVar_points_servesA.gridy = 10;
		panel_teamA_serves.add(CoVar_points_servesA, gbc_CoVar_points_servesA);
		
		CoVar_faults_servesA = new JLabel("0.0");
		GridBagConstraints gbc_CoVar_faults_servesA = new GridBagConstraints();
		gbc_CoVar_faults_servesA.insets = new Insets(0, 0, 5, 5);
		gbc_CoVar_faults_servesA.gridx = 4;
		gbc_CoVar_faults_servesA.gridy = 10;
		panel_teamA_serves.add(CoVar_faults_servesA, gbc_CoVar_faults_servesA);
		
		label_23 = new JLabel("correlation");
		GridBagConstraints gbc_label_23 = new GridBagConstraints();
		gbc_label_23.insets = new Insets(0, 0, 5, 5);
		gbc_label_23.gridx = 1;
		gbc_label_23.gridy = 11;
		panel_teamA_serves.add(label_23, gbc_label_23);
		
		Corr_points_servesA = new JLabel("0.0");
		GridBagConstraints gbc_Corr_points_servesA = new GridBagConstraints();
		gbc_Corr_points_servesA.insets = new Insets(0, 0, 5, 5);
		gbc_Corr_points_servesA.gridx = 2;
		gbc_Corr_points_servesA.gridy = 11;
		panel_teamA_serves.add(Corr_points_servesA, gbc_Corr_points_servesA);
		
		Corr_faults_servesA = new JLabel("0.0");
		GridBagConstraints gbc_Corr_faults_servesA = new GridBagConstraints();
		gbc_Corr_faults_servesA.insets = new Insets(0, 0, 5, 5);
		gbc_Corr_faults_servesA.gridx = 4;
		gbc_Corr_faults_servesA.gridy = 11;
		panel_teamA_serves.add(Corr_faults_servesA, gbc_Corr_faults_servesA);
		
		label_26 = new JLabel("SD(R)");
		GridBagConstraints gbc_label_26 = new GridBagConstraints();
		gbc_label_26.insets = new Insets(0, 0, 5, 5);
		gbc_label_26.gridx = 1;
		gbc_label_26.gridy = 12;
		panel_teamA_serves.add(label_26, gbc_label_26);
		
		SDR_points_servesA = new JLabel("0.0");
		GridBagConstraints gbc_SDR_points_servesA = new GridBagConstraints();
		gbc_SDR_points_servesA.insets = new Insets(0, 0, 5, 5);
		gbc_SDR_points_servesA.gridx = 2;
		gbc_SDR_points_servesA.gridy = 12;
		panel_teamA_serves.add(SDR_points_servesA, gbc_SDR_points_servesA);
		
		SDR_faults_servesA = new JLabel("0.0");
		GridBagConstraints gbc_SDR_faults_servesA = new GridBagConstraints();
		gbc_SDR_faults_servesA.insets = new Insets(0, 0, 5, 5);
		gbc_SDR_faults_servesA.gridx = 4;
		gbc_SDR_faults_servesA.gridy = 12;
		panel_teamA_serves.add(SDR_faults_servesA, gbc_SDR_faults_servesA);
		
		verticalStrut_11 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_11 = new GridBagConstraints();
		gbc_verticalStrut_11.insets = new Insets(0, 0, 0, 5);
		gbc_verticalStrut_11.gridx = 1;
		gbc_verticalStrut_11.gridy = 13;
		panel_teamA_serves.add(verticalStrut_11, gbc_verticalStrut_11);
		
		panel_teamB_serves = new JPanel();
		panel_teamB_serves.setBackground(Color.WHITE);
		tabbedPane.addTab(editPane.txt_teamB.getText() + " Serves", null, panel_teamB_serves, null);
		GridBagLayout gbl_panel_teamB_serves = new GridBagLayout();
		gbl_panel_teamB_serves.columnWidths = new int[]{35, 320, 0, 5, 0, 60, 0};
		gbl_panel_teamB_serves.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		gbl_panel_teamB_serves.columnWeights = new double[]{0.0, 1.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		gbl_panel_teamB_serves.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		panel_teamB_serves.setLayout(gbl_panel_teamB_serves);
		
		verticalStrut_12 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_12 = new GridBagConstraints();
		gbc_verticalStrut_12.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut_12.gridx = 1;
		gbc_verticalStrut_12.gridy = 0;
		panel_teamB_serves.add(verticalStrut_12, gbc_verticalStrut_12);
		
		lbl_Strat_TeamBServes = new JLabel("Strategy: <dynamic>");
		GridBagConstraints gbc_lbl_Strat_TeamBServes = new GridBagConstraints();
		gbc_lbl_Strat_TeamBServes.insets = new Insets(0, 0, 5, 5);
		gbc_lbl_Strat_TeamBServes.gridx = 1;
		gbc_lbl_Strat_TeamBServes.gridy = 1;
		panel_teamB_serves.add(lbl_Strat_TeamBServes, gbc_lbl_Strat_TeamBServes);
		
		verticalStrut_13 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_13 = new GridBagConstraints();
		gbc_verticalStrut_13.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut_13.gridx = 1;
		gbc_verticalStrut_13.gridy = 2;
		panel_teamB_serves.add(verticalStrut_13, gbc_verticalStrut_13);
		
		lblServeStatistic = new JLabel("Serve Statistic");
		lblServeStatistic.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lblServeStatistic = new GridBagConstraints();
		gbc_lblServeStatistic.insets = new Insets(0, 0, 5, 5);
		gbc_lblServeStatistic.gridx = 1;
		gbc_lblServeStatistic.gridy = 3;
		panel_teamB_serves.add(lblServeStatistic, gbc_lblServeStatistic);
		
		label_32 = new JLabel("mean");
		label_32.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_label_32 = new GridBagConstraints();
		gbc_label_32.insets = new Insets(0, 0, 5, 5);
		gbc_label_32.gridx = 2;
		gbc_label_32.gridy = 3;
		panel_teamB_serves.add(label_32, gbc_label_32);
		
		label_33 = new JLabel("sd");
		label_33.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_label_33 = new GridBagConstraints();
		gbc_label_33.insets = new Insets(0, 0, 5, 5);
		gbc_label_33.gridx = 4;
		gbc_label_33.gridy = 3;
		panel_teamB_serves.add(label_33, gbc_label_33);
		
		lblserves_1 = new JLabel("#serves");
		lblserves_1.setFont(new Font("Lucida Grande", Font.PLAIN, 13));
		GridBagConstraints gbc_lblserves_1 = new GridBagConstraints();
		gbc_lblserves_1.insets = new Insets(0, 0, 5, 5);
		gbc_lblserves_1.gridx = 1;
		gbc_lblserves_1.gridy = 4;
		panel_teamB_serves.add(lblserves_1, gbc_lblserves_1);
		
		lbl_value_meanServesB = new JLabel("0.0");
		GridBagConstraints gbc_lbl_value_meanServesB = new GridBagConstraints();
		gbc_lbl_value_meanServesB.insets = new Insets(0, 0, 5, 5);
		gbc_lbl_value_meanServesB.gridx = 2;
		gbc_lbl_value_meanServesB.gridy = 4;
		panel_teamB_serves.add(lbl_value_meanServesB, gbc_lbl_value_meanServesB);
		
		lbl_value_sdServesB = new JLabel("0.0");
		GridBagConstraints gbc_lbl_value_sdServesB = new GridBagConstraints();
		gbc_lbl_value_sdServesB.insets = new Insets(0, 0, 5, 5);
		gbc_lbl_value_sdServesB.gridx = 4;
		gbc_lbl_value_sdServesB.gridy = 4;
		panel_teamB_serves.add(lbl_value_sdServesB, gbc_lbl_value_sdServesB);
		
		label_37 = new JLabel("#direct points");
		label_37.setFont(new Font("Lucida Grande", Font.PLAIN, 13));
		GridBagConstraints gbc_label_37 = new GridBagConstraints();
		gbc_label_37.insets = new Insets(0, 0, 5, 5);
		gbc_label_37.gridx = 1;
		gbc_label_37.gridy = 5;
		panel_teamB_serves.add(label_37, gbc_label_37);
		
		lbl_value_meanPoints_ServesB = new JLabel("0.0");
		GridBagConstraints gbc_lbl_value_meanPoints_ServesB = new GridBagConstraints();
		gbc_lbl_value_meanPoints_ServesB.insets = new Insets(0, 0, 5, 5);
		gbc_lbl_value_meanPoints_ServesB.gridx = 2;
		gbc_lbl_value_meanPoints_ServesB.gridy = 5;
		panel_teamB_serves.add(lbl_value_meanPoints_ServesB, gbc_lbl_value_meanPoints_ServesB);
		
		lbl_value_sdPoints_servesB = new JLabel("0.0");
		GridBagConstraints gbc_lbl_value_sdPoints_servesB = new GridBagConstraints();
		gbc_lbl_value_sdPoints_servesB.insets = new Insets(0, 0, 5, 5);
		gbc_lbl_value_sdPoints_servesB.gridx = 4;
		gbc_lbl_value_sdPoints_servesB.gridy = 5;
		panel_teamB_serves.add(lbl_value_sdPoints_servesB, gbc_lbl_value_sdPoints_servesB);
		
		label_40 = new JLabel("#direct faults");
		label_40.setFont(new Font("Lucida Grande", Font.PLAIN, 13));
		GridBagConstraints gbc_label_40 = new GridBagConstraints();
		gbc_label_40.insets = new Insets(0, 0, 5, 5);
		gbc_label_40.gridx = 1;
		gbc_label_40.gridy = 6;
		panel_teamB_serves.add(label_40, gbc_label_40);
		
		lbl_value_meanFault_ServesB = new JLabel("0.0");
		GridBagConstraints gbc_lbl_value_meanFault_ServesB = new GridBagConstraints();
		gbc_lbl_value_meanFault_ServesB.insets = new Insets(0, 0, 5, 5);
		gbc_lbl_value_meanFault_ServesB.gridx = 2;
		gbc_lbl_value_meanFault_ServesB.gridy = 6;
		panel_teamB_serves.add(lbl_value_meanFault_ServesB, gbc_lbl_value_meanFault_ServesB);
		
		lbl_value_sdFault_servesB = new JLabel("0.0");
		GridBagConstraints gbc_lbl_value_sdFault_servesB = new GridBagConstraints();
		gbc_lbl_value_sdFault_servesB.insets = new Insets(0, 0, 5, 5);
		gbc_lbl_value_sdFault_servesB.gridx = 4;
		gbc_lbl_value_sdFault_servesB.gridy = 6;
		panel_teamB_serves.add(lbl_value_sdFault_servesB, gbc_lbl_value_sdFault_servesB);
		
		verticalStrut_14 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_14 = new GridBagConstraints();
		gbc_verticalStrut_14.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut_14.gridx = 1;
		gbc_verticalStrut_14.gridy = 7;
		panel_teamB_serves.add(verticalStrut_14, gbc_verticalStrut_14);
		
		lblPointsserves_1 = new JLabel("points/serves");
		lblPointsserves_1.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lblPointsserves_1 = new GridBagConstraints();
		gbc_lblPointsserves_1.insets = new Insets(0, 0, 5, 5);
		gbc_lblPointsserves_1.gridx = 2;
		gbc_lblPointsserves_1.gridy = 8;
		panel_teamB_serves.add(lblPointsserves_1, gbc_lblPointsserves_1);
		
		lblFaultsserves_1 = new JLabel("faults/serves");
		lblFaultsserves_1.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lblFaultsserves_1 = new GridBagConstraints();
		gbc_lblFaultsserves_1.insets = new Insets(0, 0, 5, 5);
		gbc_lblFaultsserves_1.gridx = 4;
		gbc_lblFaultsserves_1.gridy = 8;
		panel_teamB_serves.add(lblFaultsserves_1, gbc_lblFaultsserves_1);
		
		label_45 = new JLabel("R");
		GridBagConstraints gbc_label_45 = new GridBagConstraints();
		gbc_label_45.insets = new Insets(0, 0, 5, 5);
		gbc_label_45.gridx = 1;
		gbc_label_45.gridy = 9;
		panel_teamB_serves.add(label_45, gbc_label_45);
		
		R_Points_ServesB = new JLabel("0.0");
		GridBagConstraints gbc_R_Points_ServesB = new GridBagConstraints();
		gbc_R_Points_ServesB.insets = new Insets(0, 0, 5, 5);
		gbc_R_Points_ServesB.gridx = 2;
		gbc_R_Points_ServesB.gridy = 9;
		panel_teamB_serves.add(R_Points_ServesB, gbc_R_Points_ServesB);
		
		R_Faults_ServesB = new JLabel("0.0");
		GridBagConstraints gbc_R_Faults_ServesB = new GridBagConstraints();
		gbc_R_Faults_ServesB.insets = new Insets(0, 0, 5, 5);
		gbc_R_Faults_ServesB.gridx = 4;
		gbc_R_Faults_ServesB.gridy = 9;
		panel_teamB_serves.add(R_Faults_ServesB, gbc_R_Faults_ServesB);
		
		label_48 = new JLabel("covariance");
		GridBagConstraints gbc_label_48 = new GridBagConstraints();
		gbc_label_48.insets = new Insets(0, 0, 5, 5);
		gbc_label_48.gridx = 1;
		gbc_label_48.gridy = 10;
		panel_teamB_serves.add(label_48, gbc_label_48);
		
		CoVar_Points_ServesB = new JLabel("0.0");
		GridBagConstraints gbc_CoVar_Points_ServesB = new GridBagConstraints();
		gbc_CoVar_Points_ServesB.insets = new Insets(0, 0, 5, 5);
		gbc_CoVar_Points_ServesB.gridx = 2;
		gbc_CoVar_Points_ServesB.gridy = 10;
		panel_teamB_serves.add(CoVar_Points_ServesB, gbc_CoVar_Points_ServesB);
		
		CoVar_Faults_ServesB = new JLabel("0.0");
		GridBagConstraints gbc_CoVar_Faults_ServesB = new GridBagConstraints();
		gbc_CoVar_Faults_ServesB.insets = new Insets(0, 0, 5, 5);
		gbc_CoVar_Faults_ServesB.gridx = 4;
		gbc_CoVar_Faults_ServesB.gridy = 10;
		panel_teamB_serves.add(CoVar_Faults_ServesB, gbc_CoVar_Faults_ServesB);
		
		label_51 = new JLabel("correlation");
		GridBagConstraints gbc_label_51 = new GridBagConstraints();
		gbc_label_51.insets = new Insets(0, 0, 5, 5);
		gbc_label_51.gridx = 1;
		gbc_label_51.gridy = 11;
		panel_teamB_serves.add(label_51, gbc_label_51);
		
		Corr_Points_ServesB = new JLabel("0.0");
		GridBagConstraints gbc_Corr_Points_ServesB = new GridBagConstraints();
		gbc_Corr_Points_ServesB.insets = new Insets(0, 0, 5, 5);
		gbc_Corr_Points_ServesB.gridx = 2;
		gbc_Corr_Points_ServesB.gridy = 11;
		panel_teamB_serves.add(Corr_Points_ServesB, gbc_Corr_Points_ServesB);
		
		Corr_Faults_ServesB = new JLabel("0.0");
		GridBagConstraints gbc_Corr_Faults_ServesB = new GridBagConstraints();
		gbc_Corr_Faults_ServesB.insets = new Insets(0, 0, 5, 5);
		gbc_Corr_Faults_ServesB.gridx = 4;
		gbc_Corr_Faults_ServesB.gridy = 11;
		panel_teamB_serves.add(Corr_Faults_ServesB, gbc_Corr_Faults_ServesB);
		
		label_54 = new JLabel("SD(R)");
		GridBagConstraints gbc_label_54 = new GridBagConstraints();
		gbc_label_54.insets = new Insets(0, 0, 5, 5);
		gbc_label_54.gridx = 1;
		gbc_label_54.gridy = 12;
		panel_teamB_serves.add(label_54, gbc_label_54);
		
		SDR_Points_ServesB = new JLabel("0.0");
		GridBagConstraints gbc_SDR_Points_ServesB = new GridBagConstraints();
		gbc_SDR_Points_ServesB.insets = new Insets(0, 0, 5, 5);
		gbc_SDR_Points_ServesB.gridx = 2;
		gbc_SDR_Points_ServesB.gridy = 12;
		panel_teamB_serves.add(SDR_Points_ServesB, gbc_SDR_Points_ServesB);
		
		SDR_Faults_ServesB = new JLabel("0.0");
		GridBagConstraints gbc_SDR_Faults_ServesB = new GridBagConstraints();
		gbc_SDR_Faults_ServesB.insets = new Insets(0, 0, 5, 5);
		gbc_SDR_Faults_ServesB.gridx = 4;
		gbc_SDR_Faults_ServesB.gridy = 12;
		panel_teamB_serves.add(SDR_Faults_ServesB, gbc_SDR_Faults_ServesB);
		
		verticalStrut_15 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_15 = new GridBagConstraints();
		gbc_verticalStrut_15.insets = new Insets(0, 0, 0, 5);
		gbc_verticalStrut_15.gridx = 1;
		gbc_verticalStrut_15.gridy = 13;
		panel_teamB_serves.add(verticalStrut_15, gbc_verticalStrut_15);
		
		JPanel panel_teamA_fA = new JPanel();
		tabbedPane.addTab(editPane.txt_teamA.getText() + " Field Attacks", null, panel_teamA_fA, "Statistics Team A");
		tabbedPane.setEnabledAt(2, true);
		panel_teamA_fA.setBackground(Color.WHITE);
		GridBagLayout gbl_panel_teamA_fA = new GridBagLayout();
		gbl_panel_teamA_fA.columnWidths = new int[]{35, 320, 0, 5, 0, 60, 0};
		gbl_panel_teamA_fA.rowHeights = new int[] {0, 0, 0, 18, 18, 18, 18, 0, 0, 0, 0, 0, 0, 0, 0};
		gbl_panel_teamA_fA.columnWeights = new double[]{0.0, 1.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		gbl_panel_teamA_fA.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, Double.MIN_VALUE};
		panel_teamA_fA.setLayout(gbl_panel_teamA_fA);
		
		verticalStrut = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut = new GridBagConstraints();
		gbc_verticalStrut.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut.gridx = 1;
		gbc_verticalStrut.gridy = 0;
		panel_teamA_fA.add(verticalStrut, gbc_verticalStrut);
		
		lblStrategy_teamA = new JLabel("Strategy: ");
		GridBagConstraints gbc_lblStrategy_teamA = new GridBagConstraints();
		gbc_lblStrategy_teamA.insets = new Insets(0, 0, 5, 5);
		gbc_lblStrategy_teamA.gridx = 1;
		gbc_lblStrategy_teamA.gridy = 1;
		panel_teamA_fA.add(lblStrategy_teamA, gbc_lblStrategy_teamA);
		
		verticalStrut_6 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_6 = new GridBagConstraints();
		gbc_verticalStrut_6.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut_6.gridx = 1;
		gbc_verticalStrut_6.gridy = 2;
		panel_teamA_fA.add(verticalStrut_6, gbc_verticalStrut_6);
		
		lblFieldAttackStatistic = new JLabel("Field Attack Statistic");
		lblFieldAttackStatistic.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lblFieldAttackStatistic = new GridBagConstraints();
		gbc_lblFieldAttackStatistic.insets = new Insets(0, 0, 5, 5);
		gbc_lblFieldAttackStatistic.gridx = 1;
		gbc_lblFieldAttackStatistic.gridy = 3;
		panel_teamA_fA.add(lblFieldAttackStatistic, gbc_lblFieldAttackStatistic);
		
		lblMean = new JLabel("mean");
		lblMean.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lblMean = new GridBagConstraints();
		gbc_lblMean.insets = new Insets(0, 0, 5, 5);
		gbc_lblMean.gridx = 2;
		gbc_lblMean.gridy = 3;
		panel_teamA_fA.add(lblMean, gbc_lblMean);
		
		lblSd = new JLabel("sd");
		lblSd.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lblSd = new GridBagConstraints();
		gbc_lblSd.insets = new Insets(0, 0, 5, 5);
		gbc_lblSd.gridx = 4;
		gbc_lblSd.gridy = 3;
		panel_teamA_fA.add(lblSd, gbc_lblSd);
		
		lblAttacks = new JLabel("#attacks");
		GridBagConstraints gbc_lblAttacks = new GridBagConstraints();
		gbc_lblAttacks.insets = new Insets(0, 0, 5, 5);
		gbc_lblAttacks.gridx = 1;
		gbc_lblAttacks.gridy = 4;
		panel_teamA_fA.add(lblAttacks, gbc_lblAttacks);
		
		lblValuemeanattacks = new JLabel("valueMeanAttacks");
		GridBagConstraints gbc_lblValuemeanattacks = new GridBagConstraints();
		gbc_lblValuemeanattacks.insets = new Insets(0, 0, 5, 5);
		gbc_lblValuemeanattacks.gridx = 2;
		gbc_lblValuemeanattacks.gridy = 4;
		panel_teamA_fA.add(lblValuemeanattacks, gbc_lblValuemeanattacks);
		
		lblValuesdattacks = new JLabel("valueSDAttacks");
		GridBagConstraints gbc_lblValuesdattacks = new GridBagConstraints();
		gbc_lblValuesdattacks.insets = new Insets(0, 0, 5, 5);
		gbc_lblValuesdattacks.gridx = 4;
		gbc_lblValuesdattacks.gridy = 4;
		panel_teamA_fA.add(lblValuesdattacks, gbc_lblValuesdattacks);
		
		lbldirectPoints = new JLabel("#direct points");
		GridBagConstraints gbc_lbldirectPoints = new GridBagConstraints();
		gbc_lbldirectPoints.insets = new Insets(0, 0, 5, 5);
		gbc_lbldirectPoints.gridx = 1;
		gbc_lbldirectPoints.gridy = 5;
		panel_teamA_fA.add(lbldirectPoints, gbc_lbldirectPoints);
		
		lblValuemeanpoints = new JLabel("valueMeanPoints");
		GridBagConstraints gbc_lblValuemeanpoints = new GridBagConstraints();
		gbc_lblValuemeanpoints.insets = new Insets(0, 0, 5, 5);
		gbc_lblValuemeanpoints.gridx = 2;
		gbc_lblValuemeanpoints.gridy = 5;
		panel_teamA_fA.add(lblValuemeanpoints, gbc_lblValuemeanpoints);
		
		lblSdpoints = new JLabel("SDPoints");
		GridBagConstraints gbc_lblSdpoints = new GridBagConstraints();
		gbc_lblSdpoints.insets = new Insets(0, 0, 5, 5);
		gbc_lblSdpoints.gridx = 4;
		gbc_lblSdpoints.gridy = 5;
		panel_teamA_fA.add(lblSdpoints, gbc_lblSdpoints);
		
		lbldirectFaults = new JLabel("#direct faults");
		GridBagConstraints gbc_lbldirectFaults = new GridBagConstraints();
		gbc_lbldirectFaults.insets = new Insets(0, 0, 5, 5);
		gbc_lbldirectFaults.gridx = 1;
		gbc_lbldirectFaults.gridy = 6;
		panel_teamA_fA.add(lbldirectFaults, gbc_lbldirectFaults);
		
		lblValuemeanfaults = new JLabel("valueMeanFaults");
		GridBagConstraints gbc_lblValuemeanfaults = new GridBagConstraints();
		gbc_lblValuemeanfaults.insets = new Insets(0, 0, 5, 5);
		gbc_lblValuemeanfaults.gridx = 2;
		gbc_lblValuemeanfaults.gridy = 6;
		panel_teamA_fA.add(lblValuemeanfaults, gbc_lblValuemeanfaults);
		
		lblSdfaults = new JLabel("SDFaults");
		GridBagConstraints gbc_lblSdfaults = new GridBagConstraints();
		gbc_lblSdfaults.insets = new Insets(0, 0, 5, 5);
		gbc_lblSdfaults.gridx = 4;
		gbc_lblSdfaults.gridy = 6;
		panel_teamA_fA.add(lblSdfaults, gbc_lblSdfaults);
		
		verticalStrut_1 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_1 = new GridBagConstraints();
		gbc_verticalStrut_1.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut_1.gridx = 1;
		gbc_verticalStrut_1.gridy = 7;
		panel_teamA_fA.add(verticalStrut_1, gbc_verticalStrut_1);
		
		lblPointsattacks = new JLabel("points/attacks");
		lblPointsattacks.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lblPointsattacks = new GridBagConstraints();
		gbc_lblPointsattacks.insets = new Insets(0, 0, 5, 5);
		gbc_lblPointsattacks.gridx = 2;
		gbc_lblPointsattacks.gridy = 8;
		panel_teamA_fA.add(lblPointsattacks, gbc_lblPointsattacks);
		
		lblFaultsattacks = new JLabel("faults/attacks");
		lblFaultsattacks.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lblFaultsattacks = new GridBagConstraints();
		gbc_lblFaultsattacks.insets = new Insets(0, 0, 5, 5);
		gbc_lblFaultsattacks.gridx = 4;
		gbc_lblFaultsattacks.gridy = 8;
		panel_teamA_fA.add(lblFaultsattacks, gbc_lblFaultsattacks);
		
		lblR = new JLabel("R");
		GridBagConstraints gbc_lblR = new GridBagConstraints();
		gbc_lblR.insets = new Insets(0, 0, 5, 5);
		gbc_lblR.gridx = 1;
		gbc_lblR.gridy = 9;
		panel_teamA_fA.add(lblR, gbc_lblR);
		
		lblRpoints = new JLabel("Rpoints");
		GridBagConstraints gbc_lblRpoints = new GridBagConstraints();
		gbc_lblRpoints.insets = new Insets(0, 0, 5, 5);
		gbc_lblRpoints.gridx = 2;
		gbc_lblRpoints.gridy = 9;
		panel_teamA_fA.add(lblRpoints, gbc_lblRpoints);
		
		lblRfaults = new JLabel("Rfaults");
		GridBagConstraints gbc_lblRfaults = new GridBagConstraints();
		gbc_lblRfaults.insets = new Insets(0, 0, 5, 5);
		gbc_lblRfaults.gridx = 4;
		gbc_lblRfaults.gridy = 9;
		panel_teamA_fA.add(lblRfaults, gbc_lblRfaults);
		
		lblCovariance = new JLabel("covariance");
		GridBagConstraints gbc_lblCovariance = new GridBagConstraints();
		gbc_lblCovariance.insets = new Insets(0, 0, 5, 5);
		gbc_lblCovariance.gridx = 1;
		gbc_lblCovariance.gridy = 10;
		panel_teamA_fA.add(lblCovariance, gbc_lblCovariance);
		
		lblCovarpoints = new JLabel("coVarPoints");
		GridBagConstraints gbc_lblCovarpoints = new GridBagConstraints();
		gbc_lblCovarpoints.insets = new Insets(0, 0, 5, 5);
		gbc_lblCovarpoints.gridx = 2;
		gbc_lblCovarpoints.gridy = 10;
		panel_teamA_fA.add(lblCovarpoints, gbc_lblCovarpoints);
		
		lblCovarfaults = new JLabel("coVarFaults");
		GridBagConstraints gbc_lblCovarfaults = new GridBagConstraints();
		gbc_lblCovarfaults.insets = new Insets(0, 0, 5, 5);
		gbc_lblCovarfaults.gridx = 4;
		gbc_lblCovarfaults.gridy = 10;
		panel_teamA_fA.add(lblCovarfaults, gbc_lblCovarfaults);
		
		JLabel lblCorrelation = new JLabel("correlation");
		GridBagConstraints gbc_lblCorrelation = new GridBagConstraints();
		gbc_lblCorrelation.insets = new Insets(0, 0, 5, 5);
		gbc_lblCorrelation.gridx = 1;
		gbc_lblCorrelation.gridy = 11;
		panel_teamA_fA.add(lblCorrelation, gbc_lblCorrelation);
		
		lblCorrpoints = new JLabel("corrPoints");
		GridBagConstraints gbc_lblCorrpoints = new GridBagConstraints();
		gbc_lblCorrpoints.insets = new Insets(0, 0, 5, 5);
		gbc_lblCorrpoints.gridx = 2;
		gbc_lblCorrpoints.gridy = 11;
		panel_teamA_fA.add(lblCorrpoints, gbc_lblCorrpoints);
		
		lblCorrfaults = new JLabel("corrFaults");
		GridBagConstraints gbc_lblCorrfaults = new GridBagConstraints();
		gbc_lblCorrfaults.insets = new Insets(0, 0, 5, 5);
		gbc_lblCorrfaults.gridx = 4;
		gbc_lblCorrfaults.gridy = 11;
		panel_teamA_fA.add(lblCorrfaults, gbc_lblCorrfaults);
		
		lblSdr = new JLabel("SD(R)");
		GridBagConstraints gbc_lblSdr = new GridBagConstraints();
		gbc_lblSdr.insets = new Insets(0, 0, 5, 5);
		gbc_lblSdr.gridx = 1;
		gbc_lblSdr.gridy = 12;
		panel_teamA_fA.add(lblSdr, gbc_lblSdr);
		
		lblSdrpoints = new JLabel("SDRPoints");
		GridBagConstraints gbc_lblSdrpoints = new GridBagConstraints();
		gbc_lblSdrpoints.insets = new Insets(0, 0, 5, 5);
		gbc_lblSdrpoints.gridx = 2;
		gbc_lblSdrpoints.gridy = 12;
		panel_teamA_fA.add(lblSdrpoints, gbc_lblSdrpoints);
		
		lblSdrfaults = new JLabel("SDRFaults");
		GridBagConstraints gbc_lblSdrfaults = new GridBagConstraints();
		gbc_lblSdrfaults.insets = new Insets(0, 0, 5, 5);
		gbc_lblSdrfaults.gridx = 4;
		gbc_lblSdrfaults.gridy = 12;
		panel_teamA_fA.add(lblSdrfaults, gbc_lblSdrfaults);
		
		verticalStrut_2 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_2 = new GridBagConstraints();
		gbc_verticalStrut_2.insets = new Insets(0, 0, 0, 5);
		gbc_verticalStrut_2.gridx = 1;
		gbc_verticalStrut_2.gridy = 13;
		panel_teamA_fA.add(verticalStrut_2, gbc_verticalStrut_2);
	
		
		
		
		/////////////////////////////
		// TEAM B
		//////////////////////////////
		panel_teamB_fA = new JPanel();
		panel_teamB_fA.setBackground(Color.WHITE);
		tabbedPane.addTab(editPane.txt_teamB.getText() + " Field Attacks", null, panel_teamB_fA, null);
		GridBagLayout gbl_panel_teamB_fA = new GridBagLayout();
		gbl_panel_teamB_fA.columnWidths = new int[]{35, 320, 0, 5, 0, 60, 0};
		gbl_panel_teamB_fA.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		gbl_panel_teamB_fA.columnWeights = new double[]{0.0, 1.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		gbl_panel_teamB_fA.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		panel_teamB_fA.setLayout(gbl_panel_teamB_fA);
		
		verticalStrut_5 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_5 = new GridBagConstraints();
		gbc_verticalStrut_5.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut_5.gridx = 1;
		gbc_verticalStrut_5.gridy = 0;
		panel_teamB_fA.add(verticalStrut_5, gbc_verticalStrut_5);
		
		lblStrategy_teamB = new JLabel("Strategy");
		GridBagConstraints gbc_lblStrategy_teamB = new GridBagConstraints();
		gbc_lblStrategy_teamB.insets = new Insets(0, 0, 5, 5);
		gbc_lblStrategy_teamB.gridx = 1;
		gbc_lblStrategy_teamB.gridy = 1;
		panel_teamB_fA.add(lblStrategy_teamB, gbc_lblStrategy_teamB);
		
		verticalStrut_7 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_7 = new GridBagConstraints();
		gbc_verticalStrut_7.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut_7.gridx = 1;
		gbc_verticalStrut_7.gridy = 2;
		panel_teamB_fA.add(verticalStrut_7, gbc_verticalStrut_7);
		
		label = new JLabel("Field Attack Statistic");
		label.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_label = new GridBagConstraints();
		gbc_label.insets = new Insets(0, 0, 5, 5);
		gbc_label.gridx = 1;
		gbc_label.gridy = 3;
		panel_teamB_fA.add(label, gbc_label);
		
		lblMeanB = new JLabel("mean");
		lblMeanB.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lblMeanB = new GridBagConstraints();
		gbc_lblMeanB.insets = new Insets(0, 0, 5, 5);
		gbc_lblMeanB.gridx = 2;
		gbc_lblMeanB.gridy = 3;
		panel_teamB_fA.add(lblMeanB, gbc_lblMeanB);
		
		lblSdB = new JLabel("sd");
		lblSdB.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lblSdB = new GridBagConstraints();
		gbc_lblSdB.insets = new Insets(0, 0, 5, 5);
		gbc_lblSdB.gridx = 4;
		gbc_lblSdB.gridy = 3;
		panel_teamB_fA.add(lblSdB, gbc_lblSdB);
		
		lblAttacksB = new JLabel("#attacks");
		lblAttacksB.setFont(new Font("Lucida Grande", Font.PLAIN, 13));
		GridBagConstraints gbc_lblAttacksB = new GridBagConstraints();
		gbc_lblAttacksB.insets = new Insets(0, 0, 5, 5);
		gbc_lblAttacksB.gridx = 1;
		gbc_lblAttacksB.gridy = 4;
		panel_teamB_fA.add(lblAttacksB, gbc_lblAttacksB);
		
		lblValuemeanattacksB = new JLabel("valuemeanattacks");
		GridBagConstraints gbc_lblValuemeanattacksB = new GridBagConstraints();
		gbc_lblValuemeanattacksB.insets = new Insets(0, 0, 5, 5);
		gbc_lblValuemeanattacksB.gridx = 2;
		gbc_lblValuemeanattacksB.gridy = 4;
		panel_teamB_fA.add(lblValuemeanattacksB, gbc_lblValuemeanattacksB);
		
		lblValuesdattacksB = new JLabel("valuesdattacks");
		GridBagConstraints gbc_lblValuesdattacksB = new GridBagConstraints();
		gbc_lblValuesdattacksB.insets = new Insets(0, 0, 5, 5);
		gbc_lblValuesdattacksB.gridx = 4;
		gbc_lblValuesdattacksB.gridy = 4;
		panel_teamB_fA.add(lblValuesdattacksB, gbc_lblValuesdattacksB);
		
		lbldirectPointsB = new JLabel("#direct points");
		lbldirectPointsB.setFont(new Font("Lucida Grande", Font.PLAIN, 13));
		GridBagConstraints gbc_lbldirectPointsB = new GridBagConstraints();
		gbc_lbldirectPointsB.insets = new Insets(0, 0, 5, 5);
		gbc_lbldirectPointsB.gridx = 1;
		gbc_lbldirectPointsB.gridy = 5;
		panel_teamB_fA.add(lbldirectPointsB, gbc_lbldirectPointsB);
		
		lblValuemeanpointsB = new JLabel("valuemeanpoints");
		GridBagConstraints gbc_lblValuemeanpointsB = new GridBagConstraints();
		gbc_lblValuemeanpointsB.insets = new Insets(0, 0, 5, 5);
		gbc_lblValuemeanpointsB.gridx = 2;
		gbc_lblValuemeanpointsB.gridy = 5;
		panel_teamB_fA.add(lblValuemeanpointsB, gbc_lblValuemeanpointsB);
		
		lblValuesdpointsB = new JLabel("valuesdpoints");
		GridBagConstraints gbc_lblValuesdpointsB = new GridBagConstraints();
		gbc_lblValuesdpointsB.insets = new Insets(0, 0, 5, 5);
		gbc_lblValuesdpointsB.gridx = 4;
		gbc_lblValuesdpointsB.gridy = 5;
		panel_teamB_fA.add(lblValuesdpointsB, gbc_lblValuesdpointsB);
		
		lbldirectFaultsB = new JLabel("#direct faults");
		lbldirectFaultsB.setFont(new Font("Lucida Grande", Font.PLAIN, 13));
		GridBagConstraints gbc_lbldirectFaultsB = new GridBagConstraints();
		gbc_lbldirectFaultsB.insets = new Insets(0, 0, 5, 5);
		gbc_lbldirectFaultsB.gridx = 1;
		gbc_lbldirectFaultsB.gridy = 6;
		panel_teamB_fA.add(lbldirectFaultsB, gbc_lbldirectFaultsB);
		
		lblValuemeanfaultsB = new JLabel("valuemeanfaults");
		GridBagConstraints gbc_lblValuemeanfaultsB = new GridBagConstraints();
		gbc_lblValuemeanfaultsB.insets = new Insets(0, 0, 5, 5);
		gbc_lblValuemeanfaultsB.gridx = 2;
		gbc_lblValuemeanfaultsB.gridy = 6;
		panel_teamB_fA.add(lblValuemeanfaultsB, gbc_lblValuemeanfaultsB);
		
		lblValuesdfaultsB = new JLabel("valuesdfaults");
		GridBagConstraints gbc_lblValuesdfaultsB = new GridBagConstraints();
		gbc_lblValuesdfaultsB.insets = new Insets(0, 0, 5, 5);
		gbc_lblValuesdfaultsB.gridx = 4;
		gbc_lblValuesdfaultsB.gridy = 6;
		panel_teamB_fA.add(lblValuesdfaultsB, gbc_lblValuesdfaultsB);
		
		verticalStrut_4 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_4 = new GridBagConstraints();
		gbc_verticalStrut_4.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut_4.gridx = 1;
		gbc_verticalStrut_4.gridy = 7;
		panel_teamB_fA.add(verticalStrut_4, gbc_verticalStrut_4);
		
		lblPointsattacksB = new JLabel("points/attacks");
		lblPointsattacksB.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lblPointsattacksB = new GridBagConstraints();
		gbc_lblPointsattacksB.insets = new Insets(0, 0, 5, 5);
		gbc_lblPointsattacksB.gridx = 2;
		gbc_lblPointsattacksB.gridy = 8;
		panel_teamB_fA.add(lblPointsattacksB, gbc_lblPointsattacksB);
		
		lblFaultsattacksB = new JLabel("faults/attacks");
		lblFaultsattacksB.setFont(new Font("Lucida Grande", Font.BOLD, 13));
		GridBagConstraints gbc_lblFaultsattacksB = new GridBagConstraints();
		gbc_lblFaultsattacksB.insets = new Insets(0, 0, 5, 5);
		gbc_lblFaultsattacksB.gridx = 4;
		gbc_lblFaultsattacksB.gridy = 8;
		panel_teamB_fA.add(lblFaultsattacksB, gbc_lblFaultsattacksB);
		
		lblRB = new JLabel("R");
		GridBagConstraints gbc_lblRB = new GridBagConstraints();
		gbc_lblRB.insets = new Insets(0, 0, 5, 5);
		gbc_lblRB.gridx = 1;
		gbc_lblRB.gridy = 9;
		panel_teamB_fA.add(lblRB, gbc_lblRB);
		
		lblRpointsB = new JLabel("RpointsB");
		GridBagConstraints gbc_lblRpointsB = new GridBagConstraints();
		gbc_lblRpointsB.insets = new Insets(0, 0, 5, 5);
		gbc_lblRpointsB.gridx = 2;
		gbc_lblRpointsB.gridy = 9;
		panel_teamB_fA.add(lblRpointsB, gbc_lblRpointsB);
		
		lblRfaultsb = new JLabel("RfaultsB");
		GridBagConstraints gbc_lblRfaultsb = new GridBagConstraints();
		gbc_lblRfaultsb.insets = new Insets(0, 0, 5, 5);
		gbc_lblRfaultsb.gridx = 4;
		gbc_lblRfaultsb.gridy = 9;
		panel_teamB_fA.add(lblRfaultsb, gbc_lblRfaultsb);
		
		lblCovarianceB = new JLabel("covariance");
		GridBagConstraints gbc_lblCovarianceB = new GridBagConstraints();
		gbc_lblCovarianceB.insets = new Insets(0, 0, 5, 5);
		gbc_lblCovarianceB.gridx = 1;
		gbc_lblCovarianceB.gridy = 10;
		panel_teamB_fA.add(lblCovarianceB, gbc_lblCovarianceB);
		
		lblCovarpointsb = new JLabel("CovarpointsB");
		GridBagConstraints gbc_lblCovarpointsb = new GridBagConstraints();
		gbc_lblCovarpointsb.insets = new Insets(0, 0, 5, 5);
		gbc_lblCovarpointsb.gridx = 2;
		gbc_lblCovarpointsb.gridy = 10;
		panel_teamB_fA.add(lblCovarpointsb, gbc_lblCovarpointsb);
		
		lblCovarfaultsb = new JLabel("CovarfaultsB");
		GridBagConstraints gbc_lblCovarfaultsb = new GridBagConstraints();
		gbc_lblCovarfaultsb.insets = new Insets(0, 0, 5, 5);
		gbc_lblCovarfaultsb.gridx = 4;
		gbc_lblCovarfaultsb.gridy = 10;
		panel_teamB_fA.add(lblCovarfaultsb, gbc_lblCovarfaultsb);
		
		lblCorrelationB = new JLabel("correlation");
		GridBagConstraints gbc_lblCorrelationB = new GridBagConstraints();
		gbc_lblCorrelationB.insets = new Insets(0, 0, 5, 5);
		gbc_lblCorrelationB.gridx = 1;
		gbc_lblCorrelationB.gridy = 11;
		panel_teamB_fA.add(lblCorrelationB, gbc_lblCorrelationB);
		
		lblCorrpointsb = new JLabel("CorrpointsB");
		GridBagConstraints gbc_lblCorrpointsb = new GridBagConstraints();
		gbc_lblCorrpointsb.insets = new Insets(0, 0, 5, 5);
		gbc_lblCorrpointsb.gridx = 2;
		gbc_lblCorrpointsb.gridy = 11;
		panel_teamB_fA.add(lblCorrpointsb, gbc_lblCorrpointsb);
		
		lblCorrfaultsb = new JLabel("CorrfaultsB");
		GridBagConstraints gbc_lblCorrfaultsb = new GridBagConstraints();
		gbc_lblCorrfaultsb.insets = new Insets(0, 0, 5, 5);
		gbc_lblCorrfaultsb.gridx = 4;
		gbc_lblCorrfaultsb.gridy = 11;
		panel_teamB_fA.add(lblCorrfaultsb, gbc_lblCorrfaultsb);
		
		lblSdrB = new JLabel("SD(R)");
		GridBagConstraints gbc_lblSdrB = new GridBagConstraints();
		gbc_lblSdrB.insets = new Insets(0, 0, 5, 5);
		gbc_lblSdrB.gridx = 1;
		gbc_lblSdrB.gridy = 12;
		panel_teamB_fA.add(lblSdrB, gbc_lblSdrB);
		
		lblSdrpointsb = new JLabel("sdrpointsB");
		GridBagConstraints gbc_lblSdrpointsb = new GridBagConstraints();
		gbc_lblSdrpointsb.insets = new Insets(0, 0, 5, 5);
		gbc_lblSdrpointsb.gridx = 2;
		gbc_lblSdrpointsb.gridy = 12;
		panel_teamB_fA.add(lblSdrpointsb, gbc_lblSdrpointsb);
		
		lblSdrfaultsb = new JLabel("sdrfaultsB");
		GridBagConstraints gbc_lblSdrfaultsb = new GridBagConstraints();
		gbc_lblSdrfaultsb.insets = new Insets(0, 0, 5, 5);
		gbc_lblSdrfaultsb.gridx = 4;
		gbc_lblSdrfaultsb.gridy = 12;
		panel_teamB_fA.add(lblSdrfaultsb, gbc_lblSdrfaultsb);
		
		verticalStrut_3 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_3 = new GridBagConstraints();
		gbc_verticalStrut_3.insets = new Insets(0, 0, 0, 5);
		gbc_verticalStrut_3.gridx = 1;
		gbc_verticalStrut_3.gridy = 13;
		panel_teamB_fA.add(verticalStrut_3, gbc_verticalStrut_3);
		
		Validation = new JPanel();
		Validation.setBackground(Color.WHITE);
		tabbedPane.addTab("Summary", null, Validation, null);
		GridBagLayout gbl_Validation = new GridBagLayout();
		gbl_Validation.columnWidths = new int[]{0, 0, 0, 0, 0, 0};
		gbl_Validation.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0};
		gbl_Validation.columnWeights = new double[]{1.0, 0.0, 0.0, 0.0, 1.0, Double.MIN_VALUE};
		gbl_Validation.rowWeights = new double[]{1.0, 0.0, 0.0, 0.0, 0.0, 1.0, Double.MIN_VALUE};
		Validation.setLayout(gbl_Validation);
		
		lblValidation = new JLabel("Validation");
		lblValidation.setFont(new Font("Lucida Grande", Font.BOLD, 15));
		GridBagConstraints gbc_lblValidation = new GridBagConstraints();
		gbc_lblValidation.insets = new Insets(0, 0, 5, 5);
		gbc_lblValidation.gridx = 1;
		gbc_lblValidation.gridy = 1;
		Validation.add(lblValidation, gbc_lblValidation);
		
		lblGewonneneStzeTeam_1 = new JLabel("Won sets by team " + editPane.txt_teamA.getText());
		GridBagConstraints gbc_lblGewonneneStzeTeam_1 = new GridBagConstraints();
		gbc_lblGewonneneStzeTeam_1.insets = new Insets(0, 0, 5, 5);
		gbc_lblGewonneneStzeTeam_1.gridx = 1;
		gbc_lblGewonneneStzeTeam_1.gridy = 3;
		Validation.add(lblGewonneneStzeTeam_1, gbc_lblGewonneneStzeTeam_1);
		
		lblWonsets_1 = new JLabel("wonSets");
		GridBagConstraints gbc_lblWonsets_1 = new GridBagConstraints();
		gbc_lblWonsets_1.insets = new Insets(0, 0, 5, 5);
		gbc_lblWonsets_1.gridx = 3;
		gbc_lblWonsets_1.gridy = 3;
		Validation.add(lblWonsets_1, gbc_lblWonsets_1);
		
		lblSatzGewinnwahrscheinlichkeit = new JLabel("Set-winning-probability");
		GridBagConstraints gbc_lblSatzGewinnwahrscheinlichkeit = new GridBagConstraints();
		gbc_lblSatzGewinnwahrscheinlichkeit.insets = new Insets(0, 0, 5, 5);
		gbc_lblSatzGewinnwahrscheinlichkeit.gridx = 1;
		gbc_lblSatzGewinnwahrscheinlichkeit.gridy = 4;
		Validation.add(lblSatzGewinnwahrscheinlichkeit, gbc_lblSatzGewinnwahrscheinlichkeit);
		
		lblWonsetsprob_1 = new JLabel("wonSetsProb");
		GridBagConstraints gbc_lblWonsetsprob_1 = new GridBagConstraints();
		gbc_lblWonsetsprob_1.insets = new Insets(0, 0, 5, 5);
		gbc_lblWonsetsprob_1.gridx = 3;
		gbc_lblWonsetsprob_1.gridy = 4;
		Validation.add(lblWonsetsprob_1, gbc_lblWonsetsprob_1);
		
		JPanel BtnPanel = new JPanel();
		FlowLayout flowLayout = (FlowLayout) BtnPanel.getLayout();
		flowLayout.setAlignment(FlowLayout.TRAILING);
		getContentPane().add(BtnPanel, BorderLayout.SOUTH);
		
		JButton btnClose = new JButton("Close");
		btnClose.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent arg0) {
				// Spiel zur�cksetzen, Statistik wird automatisch neues Objekt erzeugt
				Game.getInstance().resetGame();				

				dispose();				
			}		
		});
		BtnPanel.add(btnClose);
		
		JButton btnRepeat = new JButton("Repeat");
		btnRepeat.addActionListener(new ActionListener() {			
			@Override
			public void actionPerformed(ActionEvent e) {

				GUIManager.getInstance().getMainFrame().setWaitDialog(new WaitDialog());
				WaitDialog dialog = GUIManager.getInstance().getMainFrame().getWaitDialog();
				
				// Spiel zur�cksetzen, Statistik wird automatisch neues Objekt erzeugt
				Game.getInstance().resetGame();

				SimSwingWorker repeatSimTask = new SimSwingWorker(false, 0, false);		
				repeatSimTask.execute(); 
			    dialog.setLocationRelativeTo(ResultFrame.this);
			    dialog.setVisible(true);
			}
		});
		
		BtnPanel.add(btnRepeat);

		loadResults(sim);
	}
	
	private void loadResults(SimulationManager sim){
		// Team A - Serves
		lbl_Strat_teamA_serve.setText("Strategy: " + Game.getInstance().getTeamA().getStrat().toString());
		
		mean_servesA.setText(String.valueOf(myRound(sim.teamA_servesampleMean[0], 6)));
		mean_points_servesA.setText(String.valueOf(myRound(sim.teamA_servesampleMean[1], 6)));
		mean_faults_servesA.setText(String.valueOf(myRound(sim.teamA_servesampleMean[2], 6)));
		
		sd_servesA.setText(String.valueOf(myRound(sim.teamA_servesampleSD[0], 6)));
		sd_points_servesA.setText(String.valueOf(myRound(sim.teamA_servesampleSD[1], 6)));
		sd_faults_servesA.setText(String.valueOf(myRound(sim.teamA_servesampleSD[2], 6)));
		
		R_points_servesA.setText(String.valueOf(myRound(sim.teamA_serveR[0], 6)));
		R_faults_servesA.setText(String.valueOf(myRound(sim.teamA_serveR[1], 6)));
		
		CoVar_points_servesA.setText(String.valueOf(myRound(sim.teamA_servecoVar[0], 6)));
		CoVar_faults_servesA.setText(String.valueOf(myRound(sim.teamA_servecoVar[1], 6)));
		
		Corr_points_servesA.setText(String.valueOf(myRound(sim.teamA_servecorr[0], 6)));
		Corr_faults_servesA.setText(String.valueOf(myRound(sim.teamA_servecorr[1], 6)));
		
		SDR_points_servesA.setText(String.valueOf(myRound(sim.teamA_serveSDR[0], 6)));
		SDR_faults_servesA.setText(String.valueOf(myRound(sim.teamA_serveSDR[1], 6)));
		
		
		// Team B - Serves		
		lbl_Strat_TeamBServes.setText("Strategy: " + Game.getInstance().getTeamB().getStrat().toString());
		
		lbl_value_meanServesB.setText(String.valueOf(myRound(sim.teamB_servesampleMean[0], 6)));
		lbl_value_meanPoints_ServesB.setText(String.valueOf(myRound(sim.teamB_servesampleMean[1], 6)));
		lbl_value_meanFault_ServesB.setText(String.valueOf(myRound(sim.teamB_servesampleMean[2], 6)));
		
		lbl_value_sdServesB.setText(String.valueOf(myRound(sim.teamB_servesampleSD[0], 6)));
		lbl_value_sdPoints_servesB.setText(String.valueOf(myRound(sim.teamB_servesampleSD[1], 6)));
		lbl_value_sdFault_servesB.setText(String.valueOf(myRound(sim.teamB_servesampleSD[2], 6)));
		
		R_Points_ServesB.setText(String.valueOf(myRound(sim.teamB_serveR[0], 6)));
		R_Faults_ServesB.setText(String.valueOf(myRound(sim.teamB_serveR[1], 6)));
		
		CoVar_Points_ServesB.setText(String.valueOf(myRound(sim.teamB_servecoVar[0], 6)));
		CoVar_Faults_ServesB.setText(String.valueOf(myRound(sim.teamB_servecoVar[1], 6)));
		
		Corr_Points_ServesB.setText(String.valueOf(myRound(sim.teamB_servecorr[0], 6)));
		Corr_Faults_ServesB.setText(String.valueOf(myRound(sim.teamB_servecorr[1], 6)));
		
		SDR_Points_ServesB.setText(String.valueOf(myRound(sim.teamB_serveSDR[0], 6)));
		SDR_Faults_ServesB.setText(String.valueOf(myRound(sim.teamB_serveSDR[1], 6)));
		
		// TeamA - Field Attacks
		lblStrategy_teamA.setText("Strategy: " + Game.getInstance().getTeamA().getStrat().toString());
		
		lblValuemeanattacks.setText(String.valueOf(myRound(sim.teamA_fieldAttacksampleMean[0],6)));		
		lblValuemeanpoints.setText(String.valueOf(myRound(sim.teamA_fieldAttacksampleMean[1],6)));
		lblValuemeanfaults.setText(String.valueOf(myRound(sim.teamA_fieldAttacksampleMean[2],6)));
		
		lblValuesdattacks.setText(String.valueOf(myRound(sim.teamA_fieldAttacksampleSD[0],6)));
		lblSdpoints.setText(String.valueOf(myRound(sim.teamA_fieldAttacksampleSD[1],6)));
		lblSdfaults.setText(String.valueOf(myRound(sim.teamA_fieldAttacksampleSD[2],6)));
		
		lblRpoints.setText(String.valueOf(myRound(sim.teamA_fieldAttackR[0],6)));
		lblRfaults.setText(String.valueOf(myRound(sim.teamA_fieldAttackR[1],6)));
		
		lblCovarpoints.setText(String.valueOf(myRound(sim.teamA_fieldAttackcoVar[0],6)));
		lblCovarfaults.setText(String.valueOf(myRound(sim.teamA_fieldAttackcoVar[1],6)));
		
		lblCorrpoints.setText(String.valueOf(myRound(sim.teamA_fieldAttackcorr[0],6)));
		lblCorrfaults.setText(String.valueOf(myRound(sim.teamA_fieldAttackcorr[1],6)));
		
		lblSdrpoints.setText(String.valueOf(myRound(sim.teamA_fieldAttackSDR[0],6)));
		lblSdrfaults.setText(String.valueOf(myRound(sim.teamA_fieldAttackSDR[1],6)));
		
		
		// TeamB - Field Attacks
		
		lblStrategy_teamB.setText("Strategy: " + Game.getInstance().getTeamB().getStrat().toString());
		
		lblValuemeanattacksB.setText(String.valueOf(myRound(sim.teamB_fieldAttacksampleMean[0],6)));		
		lblValuemeanpointsB.setText(String.valueOf(myRound(sim.teamB_fieldAttacksampleMean[1],6)));
		lblValuemeanfaultsB.setText(String.valueOf(myRound(sim.teamB_fieldAttacksampleMean[2],6)));
		
		lblValuesdattacksB.setText(String.valueOf(myRound(sim.teamB_fieldAttacksampleSD[0],6)));
		lblValuesdpointsB.setText(String.valueOf(myRound(sim.teamB_fieldAttacksampleSD[1],6)));
		lblValuesdfaultsB.setText(String.valueOf(myRound(sim.teamB_fieldAttacksampleSD[2],6)));
		
		lblRpointsB.setText(String.valueOf(myRound(sim.teamB_fieldAttackR[0],6)));
		lblRfaultsb.setText(String.valueOf(myRound(sim.teamB_fieldAttackR[1],6)));
		
		lblCovarpointsb.setText(String.valueOf(myRound(sim.teamB_fieldAttackcoVar[0],6)));
		lblCovarfaultsb.setText(String.valueOf(myRound(sim.teamB_fieldAttackcoVar[1],6)));
		
		lblCorrpointsb.setText(String.valueOf(myRound(sim.teamB_fieldAttackcorr[0],6)));
		lblCorrfaultsb.setText(String.valueOf(myRound(sim.teamB_fieldAttackcorr[1],6)));
		
		lblSdrpointsb.setText(String.valueOf(myRound(sim.teamB_fieldAttackSDR[0],6)));
		lblSdrfaultsb.setText(String.valueOf(myRound(sim.teamB_fieldAttackSDR[1],6)));
		
		
		lblWonsets_1.setText(String.valueOf(sim.getWonSetsTeamA()));
		lblWonsetsprob_1.setText(String.valueOf(myRound(sim.teamA_SetWinningProb,6)));

	}
	
	
	private double myRound(double d, int stellen){
		int fac = (int) Math.pow(10, stellen);
		
		return (double) Math.round(d * fac)/fac;
	}
}
