package de.ubt.wm.sb.model;

import java.util.Arrays;
import java.util.HashSet;

public class TechniqueTest {

	private HitTechnique tech;
	
	public TechniqueTest(HitTechnique tech) {
		this.tech = tech;
	}

	public boolean isServingTechnique(){
		HashSet<HitTechnique> servingTechniques = new HashSet<HitTechnique>(Arrays.asList(HitTechnique.S_F, HitTechnique.S_J));
		
		if (servingTechniques.contains(tech)){
			return true;
		}else{
			return false;
		}
	}
	
	public boolean isAttackingTechnique(){
		HashSet<HitTechnique> attackingTechniques = new HashSet<HitTechnique>(Arrays.asList(HitTechnique.F_SM, HitTechnique.F_E, HitTechnique.F_P));
		if (attackingTechniques.contains(tech)){
			return true;
		}else{
			return false;
		}
	}

	public boolean isReceptionTechnique() {
		HashSet<HitTechnique> receivingTechniques = new HashSet<HitTechnique>(Arrays.asList(HitTechnique.r, HitTechnique.r_m));
		if (receivingTechniques.contains(tech)){
			return true;
		}else{
			return false;
		}
	}
	
	public boolean isDefendingTechnique() {
		HashSet<HitTechnique> defendingTechniques = new HashSet<HitTechnique>(Arrays.asList(HitTechnique.d, HitTechnique.d_m));
		if (defendingTechniques.contains(tech)){
			return true;
		}else{
			return false;
		}
	}
	
	public boolean isSettingTechnique() {
		HashSet<HitTechnique> settingTechniques = new HashSet<HitTechnique>(Arrays.asList(HitTechnique.s));
		if (settingTechniques.contains(tech)){
			return true;
		}else{
			return false;
		}
	}
	
//	public boolean isBlockingTechnique() {
//		HashSet<HitTechnique> settingTechniques = new HashSet<HitTechnique>(Arrays.asList(HitTechnique.b_l, HitTechnique.b_d));
//		if (settingTechniques.contains(tech)){
//			return true;
//		}else{
//			return false;
//		}
//	}
}
